// file: $DT/class/attribute_node/v1.0/attr_dbg_0.cc
//

// isip include files
//
#include "attribute_node.h"

#include "attribute_node_constants.h"
#include <integral_constants.h>

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) a open file pointer
//  char_1* message: (input) identification message
//
// return: a logical_1 value indicating the status
//
logical_1 Attribute_node::debug_cc(FILE* fp_a, char_1* message_a) {

  // dump internal data
  //
  
  if (label_d != (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> label_d = %s\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    label_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> label_d: NULL\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (type_d != ATTR_TYPE_NONE) {
    fprintf(fp_a, "<%s::%s> type_d = %ld\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    type_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> type_d: NONE\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }

  if (range_d != ATTR_RANGE_NONE) {
    fprintf(fp_a, "<%s::%s> range_d = %ld\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    range_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> range_d: NONE\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }

  if (min_d != (float_4)NULL) {
    fprintf(fp_a, "<%s::%s> min_d = %f\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    min_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> min_d: 0\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (max_d != (float_4)NULL) {
    fprintf(fp_a, "<%s::%s> max_d = %f\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    max_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> max_d: 0\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }

  if (num_values_d != (int_4)NULL) {
    fprintf(fp_a, "<%s::%s> num_values_d = %ld\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
	    num_values_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> num_values_d: 0\n",
	    ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (values_d != (char_1**)NULL) {
    for (int_4 i=0;i<num_values_d;i++) {
      fprintf(fp_a,"<%s::%s> values_d[%ld]: %s\n",
              ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a,
              i, values_d[i]);
    }
  }
  else {
    fprintf(fp_a,"<%s::%s> values_d = NULL\n",
            ATTRIBUTE_NODE_CLASS_NAME, (char*)message_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


