// file: $DT/class/attribute_node/v1.0/attr_errors_1.cc
//

// isip include files
//
#include "attribute_node.h"

#include "attribute_node_constants.h"
#include <integral_constants.h>

// method: check_errors_cc
//
// arguments: none
//
// return: a logical_1 value indicating the status
//
logical_1 Attribute_node::check_errors_cc() {

  logical_1 error_flag = ISIP_TRUE;
  
  if (label_d == (char_1*)NULL) {
    error_flag = ISIP_FALSE;
  }
  
  if (values_d == (char_1**)NULL) {
    error_flag = ISIP_FALSE;
  }
  
  if ((range_d == ATTR_RANGE_AUTO) || (range_d == ATTR_RANGE_MANUAL)) {
    if (max_d < min_d) {
      error_flag = ISIP_FALSE;
    }
  }
  
  if (type_d == ATTR_TYPE_DISCRETE) {
    if (num_values_d == (int_4)NULL) {
      error_flag = ISIP_FALSE;
    }
    if ((values_d != (char_1**)NULL) &&
	(num_values_d != (int_4)strlen((char*)values_d))) {
      error_flag = ISIP_FALSE;
    }
  }
  
  // exit gracefully
  //
  return error_flag;
}


