// file: $DT/class/attribute_node/v1.0/attr_errors_2.cc
//

// isip include files
//
#include "attribute_node.h"

#include "attribute_node_constants.h"
#include <integral_constants.h>

// method: check_errors_cc
//
// arguments:
//  FILE* fp_a file to output error messages
//
// return: a logical_1 value indicating the status
//
logical_1 Attribute_node::check_errors_cc(FILE* fp_a) {

  logical_1 error_flag = ISIP_TRUE;
  
  if (label_d == (char_1*)NULL) {
    fprintf(fp_a,"<%s> label_d: NULL\n", ATTRIBUTE_NODE_CLASS_NAME);
    error_flag = ISIP_FALSE;
  }

  if (type_d == ATTR_TYPE_NONE) {
    fprintf(fp_a,"<%s> type_d: NONE\n", ATTRIBUTE_NODE_CLASS_NAME);
    error_flag = ISIP_FALSE;
  }

  if (range_d == ATTR_RANGE_NONE) {
    fprintf(fp_a,"<%s> range_d: NONE\n", ATTRIBUTE_NODE_CLASS_NAME);
    error_flag = ISIP_FALSE;
  }

  if ((type_d != ATTR_TYPE_DISCRETE) &&
      (type_d != ATTR_TYPE_CONTINUOUS)) {
    fprintf(fp_a, "<%s> type_d: %ld\n", ATTRIBUTE_NODE_CLASS_NAME, type_d);
    error_flag = ISIP_FALSE;
  }

  if ((range_d != ATTR_RANGE_AUTO) &&
      (range_d != ATTR_RANGE_MANUAL) &&
      (range_d != ATTR_RANGE_ENUM)) {
    fprintf(fp_a,"<%s> range_d: %ld\n", ATTRIBUTE_NODE_CLASS_NAME, range_d);
    error_flag = ISIP_FALSE;
  }

  if (values_d == (char_1**)NULL) {
    fprintf(fp_a,"<%s> values_d: NULL\n", ATTRIBUTE_NODE_CLASS_NAME);
    error_flag = ISIP_FALSE;
  }
  
  if ((range_d == ATTR_RANGE_AUTO) || (range_d == ATTR_RANGE_MANUAL)) {
    if (max_d < min_d) {
      fprintf(fp_a,"<%s> max_d > min_d\n", ATTRIBUTE_NODE_CLASS_NAME);
      error_flag = ISIP_FALSE;
    }
  }

  if (type_d == ATTR_TYPE_DISCRETE) {
    if (num_values_d == (int_4)NULL) {
      fprintf(fp_a,"<%s> num_values_d: NULL\n", ATTRIBUTE_NODE_CLASS_NAME);
      error_flag = ISIP_FALSE;
    }
  }
  
  // exit gracefully
  //
  return error_flag;
}


