// file: $DT/class/attribute_node/v1.0/attr_set_1.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "attribute_node.h"
#include "attribute_node_constants.h"
#include <integral_constants.h>

// method: set_type_cc
//
// arguments:
//  int_4& type: (input) the attribute type
//
// return: a logical_1 indicating status
//
// This function sets the attribute's type
//
logical_1 Attribute_node::set_type_cc (int_4& type_a) {

  // validity check
  //
  if ((type_a != ATTR_TYPE_NONE) &&
      (type_a != ATTR_TYPE_DISCRETE) &&
      (type_a != ATTR_TYPE_CONTINUOUS)) {
    error_handler_cc((char_1*)"set_type_cc",
		     (char_1*)"invalid type encountered");
  }
  
  type_d = type_a;
    
  // exit gracefully
  //
  return ISIP_TRUE;
}


