// file: $DT/class/attribute_node/v1.0/attr_set_2.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "attribute_node.h"
#include "attribute_node_constants.h"
#include <integral_constants.h>

// method: set_range_cc
//
// arguments:
//  int_4& range: (input) the attribute range which can be auto, manual,
//                        or enumerate
//
// return: a logical_1 indicating status
//
// This function sets the attribute's range
//
logical_1 Attribute_node::set_range_cc (int_4& range_a) {

  // validity check
  //
  if ((range_a != ATTR_RANGE_NONE) &&
      (range_a != ATTR_RANGE_AUTO) &&
      (range_a != ATTR_RANGE_MANUAL) &&
      (range_a != ATTR_RANGE_ENUM)) {
    error_handler_cc((char_1*)"set_range_cc",
		     (char_1*)"invalid range encountered");
  }
  
  range_d = range_a;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


