// file: $DT/class/data_node/v1.0/data_dbg_0.cc
//

// isip include files
//
#include "data_node.h"

#include "data_node_constants.h"
#include <integral_constants.h>

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) a open file pointer
//  char_1* message: (input) identification message
//
// return: a logical_1 value indicating the status
//
logical_1 Data_node::debug_cc(FILE* fp_a, char_1* message_a) {

  // dump internal data
  //
  
  if (desc_d != (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> desc_d = %s\n",
	    DATA_NODE_CLASS_NAME, (char*)message_a, desc_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> desc_d: NULL\n",
	    DATA_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (num_items_d != (int_4)NULL) {
    fprintf(fp_a, "<%s::%s> num_items_d = %ld\n",
	    DATA_NODE_CLASS_NAME, (char*)message_a,
	    num_items_d);
  }
  else {
    fprintf(fp_a,"<%s::%s> num_items_d: NULL\n",
	    DATA_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (labels_d != (char_1**)NULL) {
    for (int_4 i=0;i<num_items_d;i++) {
      fprintf(fp_a,"<%s::%s> labels_d[%ld]: %s\n",
              DATA_NODE_CLASS_NAME, (char*)message_a,
              i, labels_d[i]);
    }
  }
  else {
    fprintf(fp_a,"<%s::%s> labels_d = NULL\n",
            DATA_NODE_CLASS_NAME, (char*)message_a);
  }
  
  if (items_d != (char_1**)NULL) {
    for (int_4 i=0;i<num_items_d;i++) {
      fprintf(fp_a,"<%s::%s> items_d[%ld]: %s\n",
              DATA_NODE_CLASS_NAME, (char*)message_a,
              i, items_d[i]);
    }
  }
  else {
    fprintf(fp_a,"<%s::%s> items_d = NULL\n",
            DATA_NODE_CLASS_NAME, (char*)message_a);
  }

  if (values_d != (float_4*)NULL) {
    for (int_4 i=0;i<num_items_d;i++) {
      fprintf(fp_a,"<%s::%s> values_d[%ld]: %f\n",
              DATA_NODE_CLASS_NAME, (char*)message_a,
              i, values_d[i]);
    }
  }
  else {
    fprintf(fp_a,"<%s::%s> values_d = NULL\n",
            DATA_NODE_CLASS_NAME, (char*)message_a);
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


