// file: $DT/class/data_node/v1.0/attr_get_2.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "data_node.h"
#include "data_node_constants.h"
#include <integral_constants.h>

// method: get_labels_cc
//
// arguments:
//  char_1** labels_a: (input) the list of data labels to return
//
// return: logical error status
//
// This function returns the list of data labels
//
logical_1 Data_node::get_labels_cc(char_1** labels_a) {
  
  // check arguments
  //
  if (labels_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"get_labels_cc",
		     (char_1*)"no memory allocated for labels");
  }

  int_4 num_labels;
  get_num_items_cc(num_labels);

  if (num_labels <= 0) {
    error_handler_cc((char_1*)"get_labels_cc",
		     (char_1*)"no element in the label list");
  }
  
  for (int_4 i=0;i<num_labels;i++) {
    if (labels_a[i] == (char_1*)NULL) {
      error_handler_cc((char_1*)"get_labels_cc",
		       (char_1*)"no memory allocated for labels");
    }
    strcpy((char*)labels_a[i], (char*)labels_d[i]);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;  
}
