// file: $DT/class/data_node/v1.0/data_get_3.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "data_node.h"
#include "data_node_constants.h"
#include <integral_constants.h>

// method: get_items_cc
//
// arguments:
//  char_1** items: (input) the list of data items to return
//
// return: logical error status
//
// This function returns the list of data items
//
logical_1 Data_node::get_items_cc(char_1** items_a) {
  
  // check arguments
  //
  if (items_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"get_items_cc",
		     (char_1*)"no memory allocated for items");
  }

  int_4 num_items;
  get_num_items_cc(num_items);
  
  if (num_items <= 0) {
    error_handler_cc((char_1*)"get_items_cc",
		     (char_1*)"no element in the label list");
  }

  for (int_4 i=0;i<num_items;i++) {
    if (items_a[i] == (char_1*)NULL) {
      error_handler_cc((char_1*)"get_items_cc",
		       (char_1*)"no memory allocated for items");
    }
    strcpy((char*)items_a[i], (char*)items_d[i]);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;  
}
