// file: $DT/class/data_node/v1.0/attr_get_4.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "data_node.h"
#include "data_node_constants.h"
#include <integral_constants.h>

// method: get_labels_cc
//
// arguments:
//  char_1* labels_a: (output) the list of data labels to return
//  int_4 index: (input) the index of the label to return
//
// return: logical error status
//
// This function returns the list of data labels
//
logical_1 Data_node::get_label_cc(char_1* label_a, int_4 index_a) {
  
  // check arguments
  //
  if (label_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_label_cc",
		     (char_1*)"no memory allocated for labels");
  }

  int_4 num_labels;
  get_num_items_cc(num_labels);

  if (num_labels <= index_a) {
    error_handler_cc((char_1*)"get_label_cc",
		     (char_1*)"index out of range");
  }
  
  if (labels_d[index_a] == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_label_cc",
		     (char_1*)"no memory allocated for labels");
  }
  else {
    strcpy((char*)label_a, (char*)labels_d[index_a]);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;  
}
