// file: $DT/class/data_node/v1.0/attr_get_4.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "data_node.h"
#include "data_node_constants.h"
#include <integral_constants.h>

// method: get_items_cc
//
// arguments:
//  char_1* items_a: (output) the list of data items to return
//  int_4 index: (input) the index of the item to return
//
// return: logical error status
//
// This function returns the list of data items
//
logical_1 Data_node::get_item_cc(char_1* item_a, int_4 index_a) {
  
  // check arguments
  //
  if (item_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_item_cc",
		     (char_1*)"no memory allocated for items");
  }

  int_4 num_items;
  get_num_items_cc(num_items);

  if (num_items <= index_a) {
    error_handler_cc((char_1*)"get_item_cc",
		     (char_1*)"index out of range");
  }
  
  if (items_d[index_a] == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_item_cc",
		     (char_1*)"no memory allocated for items");
  }
  else {
    strcpy((char*)item_a, (char*)items_d[index_a]);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;  
}
