// file: $DT/class/data_node/v1.0/data_get_8.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "data_node.h"
#include "data_node_constants.h"
#include <integral_constants.h>

// method: get_item_cc
//
// arguments:
//  char_1* item_a: (output) the item referred by label
//  char_1* label_a: (input) the label of the item to look for
//
// return: logical error status
//
// This function searches for the item referred to by label
//
logical_1 Data_node::get_item_cc(char_1* item_a, char_1* label_a) {
  
  // check arguments
  //
  if (item_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_item_cc",
		     (char_1*)"no memory allocated for items");
  }

  if (label_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_item_cc",
		     (char_1*)"no input label to search for");
  }

  int_4 num_items;
  get_num_items_cc(num_items);

  // loop until the item referred to the label is found
  //
  for (int_4 i=0;i<num_items;i++) {
    if (strcmp((char*)label_a, (char*)labels_d[i]) == 0) {
      get_item_cc(item_a, i);
      return ISIP_TRUE;
    }
  }
  
  // exit ungracefully
  //
  return ISIP_FALSE;  
}
