// file: $DT/class/data_node/v1.0/data_node.h
//
 
// make sure definitions are made only once
//
#ifndef __ISIP_DATA_NODE
#define __ISIP_DATA_NODE
 
// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// Data_node: a class that describe a data node with a description and
//            all the wonderful information associated with it
//
class Data_node {

  //---------------------------------------------------------------------------
  //
  // protected data
  //
  //---------------------------------------------------------------------------
protected:

  // declare a variable for debugging
  //
  int_4 debug_level_d;

  // the name of the data
  //
  char_1* desc_d;

  // the number of labels and items the data has
  //
  int_4 num_items_d;

  // the list of labels and items, and storage in float
  //
  char_1** labels_d;
  char_1** items_d;
  float_4* values_d;
  
  //---------------------------------------------------------------------------
  //
  // public methods
  //
  //---------------------------------------------------------------------------
public:

  // required methods
  //
  char_1* name_cc();
  volatile void error_handler_cc(char_1* method_name, char_1* message);
  logical_1 debug_cc(FILE* fp, char_1* message);
  logical_1 set_debug_cc(int_4 debug_level);
  
  // destructors/constructors
  //
  ~Data_node();
  Data_node();
  Data_node(char_1* desc, int_4 num_items, char_1** labels, char_1** items,
	    float_4* values);
  
  // method to get data information: desc, num_items, labels, and items
  //
  logical_1 get_desc_cc(char_1* desc);
  logical_1 get_num_items_cc(int_4& num_items);
  logical_1 get_labels_cc(char_1** labels);
  logical_1 get_items_cc(char_1** items);
  logical_1 get_values_cc(float_4* values);

  // get label, item, value by their index
  //
  logical_1 get_label_cc(char_1* label, int_4 index);
  logical_1 get_item_cc(char_1* item, int_4 index);
  logical_1 get_value_cc(float_4& value, int_4 index);

  // get item or value by label
  //
  logical_1 get_item_cc(char_1* item, char_1* label);
  logical_1 get_value_cc(float_4& value, char_1* label);
  
  //---------------------------------------------------------------------------
  //
  // private members
  //
  //---------------------------------------------------------------------------
private:

  // method to set data information: desc, num_items, labels, and items
  //
  logical_1 set_desc_cc(char_1* desc);
  logical_1 set_num_items_cc(int_4& num_items);
  logical_1 set_labels_cc(char_1** labels);
  logical_1 set_items_cc(char_1** items);
  logical_1 set_values_cc(float_4* values);
  //
  // end of class
  
};

//
// end of include file
#endif
