// file: $DT/class/decision_tree/v1.0/decision_tree_constants.h
//
 
// make sure the definitions are made only once
//
#ifndef __ISIP_DECISION_TREE_CONSTANTS
#define __ISIP_DECISION_TREE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// define the class name
//
#define DECISION_TREE_CLASS_NAME (char_1*)"Decision_tree"

// define limitations
//
#define DT_MAX_ATTR_FILE_SIZE (int_4)262144
#define DT_MAX_NUM_OF_ATTR_VALUES (int_4)512
#define DT_MAX_BUFFER_SIZE (int_4)8192

// define the confidence limit for use in C4 pruning
//
#define DT_CONFIDENCE_LIMIT (float_4)0.25

// define available modes
//
#define DT_MODE (char_1*)"mode"
#define DT_MODE_NONE (int_4)-1
 
#define DT_MODE_TEST (int_4)0
#define DT_MODE_TEST_NAME (char_1*)"test"
 
#define DT_MODE_TRAIN (int_4)1
#define DT_MODE_TRAIN_NAME (char_1*)"train"

// define available splitting algorithms
//
#define DT_SPLIT (char_1*)"splitting_algorithm"
#define DT_SPLIT_NONE (int_4)-1

#define DT_SPLIT_ENT (int_4)0
#define DT_SPLIT_ENT_NAME (char_1*)"entropy"

#define DT_SPLIT_BAYES (int_4)1
#define DT_SPLIT_BAYES_NAME (char_1*)"bayes"

#define DT_SPLIT_GAINRATIO (int_4)2
#define DT_SPLIT_GAINRATIO_NAME (char_1*)"gain_ratio"

// define available pruning algorithms
//
#define DT_PRUNE (char_1*)"pruning_algorithm"
#define DT_PRUNE_NONE (int_4)-1

#define DT_PRUNE_PESSIMISTIC (int_4)0
#define DT_PRUNE_PESSIMISTIC_NAME (char_1*)"pessimistic"

#define DT_PRUNE_COSTCOMPLEXITY (int_4)1
#define DT_PRUNE_COSTCOMPLEXITY_NAME (char_1*)"cost_complexity"

// define available smoothing algorithms
//
#define DT_SMOOTH (char_1*)"smoothing_algorithm"
#define DT_SMOOTH_NONE (int_4)-1
#define DT_SMOOTH_BAYES (int_4)0
#define DT_SMOOTH_BAYES_NAME (char_1*)"bayes"

// define display level
//
#define DT_DISPLAY (char_1*)"display"
#define DT_DISPLAY_NONE (int_4)-1

#define DT_DISPLAY_BASIC (int_4)0
#define DT_DISPLAY_BASIC_NAME (char_1*)"basic"

#define DT_DISPLAY_COUNT (int_4)1
#define DT_DISPLAY_COUNT_NAME (char_1*)"count"

#define DT_DISPLAY_PROB (int_4)2
#define DT_DISPLAY_PROB_NAME (char_1*)"prob"

// define name for the tree file
//
#define DT_TREE_FILENAME (char_1*)"tree_file"

// define comment tag for tree
//
#define DT_COMMENT (char_1)#

// define if data goes to left or right node
//
#define DT_SPLIT_LEFT (int_4)0
#define DT_SPLIT_RIGHT (int_4)1

// end of file
//
#endif



