// file: $DT/class/decision_tree/v1.0/dt_anode_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include <integral_constants.h>

// method: generate_nodes_cc
//
// arguments:
//  int_4    num_items (input) the number of items in each list
//  char_1** label_list_a (input) the attribute labels
//  char_1** value_list_a (input) the attribute values
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::generate_nodes_cc (int_4 num_items_a,
					    char_1** label_list_a,
					    char_1** value_list_a) {
  
  // argument validity check
  //
  if (num_items_a <= 0) {
    error_handler_cc ((char_1*)"generate_attr_node_cc",
		      (char_1*)"no items to insert in the attribute node");
  }
  
  if (label_list_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"generate_attr_node_cc",
                     (char_1*)"attribute label list is not valid");
  }

  if (value_list_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"generate_attr_node_cc",
                     (char_1*)"attribute value list is not valid");
  }

  // the first item in the attribute file should be the class
  // information, so parse the class information and put in the class
  // node
  //
  generate_class_node_cc(label_list_a[0], value_list_a[0]);
  
  // the rest of the data are the attributes, parse them and put in
  // the attribute linked list
  //
  for (int_4 i=1;i<num_items_a;i++) {
    generate_attr_node_cc(label_list_a[i], value_list_a[i]);
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


