// file: $DT/class/tree/v1.0/dt_cal_1.cc
//

// isip include files
//
#include "decision_tree.h"
#include <math.h>
#include <integral_constants.h>

// method: entropy_cc
//
// arguments:
//  int_4 count (input): the count of occurrences of one event
//  int_4 total (input): the count of all occurrences
//
// return: float_4: the entropy associated with the count and total
//
// this method calculates the entropy associated with an event given
// the number of occurrences of one event and the total number of
// events
//
float_4 Decision_tree::entropy_cc(int_4 count_a, int_4 total_a) {

  if (count_a == 0) {
    return 0;
  }
  
  // calculate p(x)
  //
  float_4 p = (float_4) count_a / (float_4) total_a;

  // return p(x) log p(x)
  //
  float_4 H =  (0 - (p * (log (p)) / (log (2))));
  return H;
}


















