// file: $DT/class/decision_tree/v1.0/dt_class_0.cc
//

// isip include files
//
#include <data_node.h>
#include <linked_list.h>
#include <tree_node_constants.h>
#include <attribute_node.h>
#include <tree_node.h>
#include <tree.h>
#include "decision_tree.h"

#include <strings.h>
#include <integral_constants.h>

// method: classify_data_cc
//
// arguments:
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::classify_data_cc () {

  int_4 count=0;
  int_4 misclassified=0;

  Linked_list* data_list_a = data_list_d;
  Data_node* current_data_file;

  while ( data_list_a != (Linked_list*)NULL ) {

    // get current data node to be classified
    //
    current_data_file = (Data_node*)data_list_a->get_node_cc();

    char_1* class_a=new char_1[ISIP_MAX_STRING_LENGTH];

    // put data file thru tree to get its class
    //
    drop_thru_tree_cc( current_data_file, tree_d->get_root_cc() , class_a);

    // check to see if the data has a tagged class
    //
    char_1* actual_class_a=new char_1[ISIP_MAX_STRING_LENGTH];

    // get filename of this data node
    //
    char_1* file_a=new char_1[ISIP_MAX_STRING_LENGTH];
    current_data_file->get_desc_cc( file_a );

    // output data filename to stdout
    //
    fprintf( stdout, "%s\t", file_a);

    delete [] file_a;
    
    if ( (current_data_file->get_item_cc( actual_class_a, (char_1*)"index" )) == ISIP_TRUE ) {

      // count number of misclassifications
      //
      if ( strcmp( (char*)actual_class_a, (char*)class_a ) != 0 )
	misclassified++;

      // increment count of data items tested
      //
      count++;

      // output actual class of the data file
      //
      fprintf( stdout, "%s\t", actual_class_a);

    }

    // output the classification
    //
    fprintf( stdout, "%s\n", class_a);
    
    delete [] class_a;
    delete [] actual_class_a;
	     
    // get next data node
    //
    data_list_a = data_list_a->get_next_cc();

  }

  // display results
  //
  float_4 error_rate = ((float_4)misclassified/(float_4)count)*100;
  
  fprintf( stdout, "\n\n\nPercent Error: %f\n", error_rate );
  fprintf( stdout, "Number of Data Items:  %ld\n", count );
  fprintf( stdout, "Number of Misclassifications:  %ld\n", misclassified );

  //
  // exit gracefully
  //
  return ISIP_TRUE;
}


