// file: $DT/class/decision_tree/v1.0/dt_class_1.cc
//

// isip include files
//
#include <data_node.h>
#include <linked_list.h>
#include <tree_node.h>
#include <tree_node_constants.h>
#include "decision_tree.h"

#include <strings.h>
#include <integral_constants.h>

// method: drop_thru_tree_cc
//
// arguments:
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::drop_thru_tree_cc ( Data_node* data_a,
					     Tree_node* tree_node_a,
					     char_1* class_a ) {

  int_4 split_type_a;
  Linked_list* children;
  Tree_node* left_child;
  Tree_node* right_child;

  if ( tree_node_a->is_terminal_cc() == ISIP_FALSE ) {

    // get children of this node
    //
    children = tree_node_a->get_children_cc();
    
    left_child = (Tree_node*)children->get_node_cc();
    
    if ( (children = children->get_next_cc()) != (Linked_list*)NULL ) {
      right_child = (Tree_node*)children->get_node_cc();
    }

    // get the type of split at the node
    //
    split_type_a=left_child->get_split_type_cc();
    
    if ( split_type_a == TREE_NODE_DISCRETE ) {
      
      char_1* value_a=new char_1[ISIP_MAX_STRING_LENGTH];
      char_1* attr_a=new char_1[ISIP_MAX_STRING_LENGTH];
      
      strcpy((char*)attr_a, (char*)(left_child->get_attribute_cc()));
      data_a->get_item_cc( value_a, attr_a );
      
      if ( left_child->ask_question_cc( value_a ) == ISIP_TRUE )
	drop_thru_tree_cc( data_a, left_child, class_a );
      else
	drop_thru_tree_cc( data_a, right_child, class_a );

      delete [] value_a;
      delete [] attr_a;
  
    }
    else {
      
      float_4 value_a;
      char_1* attr_a=new char_1[ISIP_MAX_STRING_LENGTH];
      
      strcpy((char*)attr_a, (char*)(left_child->get_attribute_cc()));
      data_a->get_value_cc( value_a, attr_a );
      
      if ( left_child->ask_question_cc( value_a ) == ISIP_TRUE )
	drop_thru_tree_cc( data_a, left_child, class_a );
      else
	drop_thru_tree_cc( data_a, right_child, class_a );

      delete [] attr_a;

    }
  }
  else {
    
    strcpy ((char*)class_a, (char*) (tree_node_a->assign_class_cc()));
  }

  //
  // exit gracefully
  //
  return ISIP_TRUE;
}


