// file: $DT/class/decision_tree/v1.0/dt_cnvt_1.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include <integral_constants.h>
#include "decision_tree.h"
// method: convert_string_cc
//
// arguments:
//  float_4& value: (output) value of the string
//  char_1* string: (input) string of value
//
// return: logical error status
//
// This function converts a string into a float
//
logical_1 Decision_tree::convert_string_cc(float_4& value_a, char_1* string_a) {
  
  // check arguments
  //
  if (string_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"convert_string_cc",
		     (char_1*)"input string is null");
  }
  
  char_1 *tmp = (char_1*)NULL;

  static char_1 whitespace_set[] = " \t";

  value_a = strtod((char*)string_a, (char**) &tmp);

  // make sure that the entire string is a long
  //
  if ((tmp != (char_1*)NULL) &&
	  (((strlen((char*)tmp) == 1) &&
	    (strchr((char*)whitespace_set, (char)*tmp) != NULL)) ||
	   ((strlen((char*)tmp) == 0)))) {
    return ISIP_TRUE;
  }

  // exit ungracefully
  //
  return ISIP_FALSE;  
}
