// file: $DT/class/decision_tree/v1.0/dt_cnvt_2.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include <integral_constants.h>
#include "decision_tree.h"
// method: convert_to_value_cc
//
// arguments:
//  float_4& value: (output) value of the string
//  char_1* string: (input) string of value
//
// return: logical error status
//
// This function converts a string into a float
//
logical_1 Decision_tree::convert_to_value_cc(int_4 num_a,
					     char_1** label_a,
					     char_1** item_a,
					     float_4* value_a) {
  
  // check arguments
  //
  if (item_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"convert_to_value_cc",
		     (char_1*)"nothing to convert");
  }

  if (value_a == (float_4*)NULL) {
    error_handler_cc((char_1*)"convert_to_value_cc",
		     (char_1*)"output memory not allocated");
  }

  if (num_a <= 0) {
    error_handler_cc((char_1*)"convert_to_value_cc",
		     (char_1*)"can't convert 0 element");
  }

  for (int_4 i=0;i<num_a-1;i++) {
    convert_string_cc(value_a[i], item_a[i]);
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
