// file: $DT/class/decision_tree/v1.0/dt_comp_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"

#include <integral_constants.h>

// method: compute_cc
//
// arguments:
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::compute_cc (char_1* fname_a) {
  

  // load in the input data
  //
  if (load_data_cc(fname_a) != ISIP_TRUE) {
    error_handler_cc((char_1*)"compute_cc", (char_1*)"unable to load data");
  }

  if (mode_d == DT_MODE_NONE) {
    
    // do nothing return
    //
    return ISIP_TRUE;
  }

  // train
  //
  else if (mode_d == DT_MODE_TRAIN) {

    if (train_cc() != ISIP_TRUE) {

      // error
      //
      error_handler_cc((char_1*)"compute_cc", (char_1*)"unable to train tree");
    }
  }

  // test
  //
  else if (mode_d == DT_MODE_TEST) {

    if (test_cc(fname_a) != ISIP_TRUE) {

      // error
      //
      error_handler_cc((char_1*)"compute_cc", (char_1*)"unable to test tree");
    }
  }

  // invalid mode
  //
  else {

    // invalid mode
    //
    error_handler_cc((char_1*)"compute_cc", (char_1*)"invalid mode");
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


