// file: $DT/class/decision_tree/v1.0/dt_cstr_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include <attribute_node.h>
#include <data_node.h>
#include <tree.h>

// method: default destructor
//
// arguments: none
//
// return: none
//
Decision_tree::~Decision_tree() {
  
  // general data needing cleanup
  //
  if (param_fname_d != (char_1*)NULL) {
    delete [] param_fname_d;
  }

  if (attr_fname_d != (char_1*)NULL) {
    delete [] attr_fname_d;
  }

  if (data_fname_d != (char_1*)NULL) {
    delete [] data_fname_d;
  }

  if (tree_fname_d != (char_1*)NULL) {
    delete [] tree_fname_d;
  }
  
  for (int_4 i=0; i<num_classes_d; i++) {
    if (class_names_d[i] != (char_1*)NULL) {
      delete [] class_names_d[i];
    }
  }
  if (class_names_d != (char_1**)NULL) {
    delete [] class_names_d;
  }
  
  delete class_prior_probs_d;
  
  // delete the class node, the attribute list and the data list
  //
  if (attribute_list_d != (Linked_list*)NULL) {
    delete attribute_list_d;
  }
  attribute_list_d = (Linked_list*)NULL;

  if (data_list_d != (Linked_list*)NULL) {
    delete data_list_d;
  }
  data_list_d = (Linked_list*)NULL;

  if (tree_d != (Tree*)NULL) {
    delete tree_d;
  }
  
  // exit gracefully
  //
}


