// file: $DT/class/decision_tree/v1.0/dt_cstr_1.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <tree.h>

#include <integral_constants.h>

// method: default constructor
//
// arguments: none
//
// return: none
//
Decision_tree::Decision_tree() {
  
  // set the default debug level
  //
  debug_level_d = ISIP_DEBUG_NONE;
  
  // initialize parameter file data
  //
  param_fname_d = (char_1*)NULL;
  attr_fname_d = (char_1*)NULL;
  data_fname_d = (char_1*)NULL;
  tree_fname_d = (char_1*)NULL;
  class_names_d = (char_1**)NULL;
  class_prior_probs_d = (float_4*)NULL;
  
  // initialize splitting, pruning, and smoothing modes
  //
  mode_d = (int_4)DT_MODE_NONE;
  mode_split_d = (int_4)DT_SPLIT_NONE;
  mode_prune_d = (int_4)DT_PRUNE_NONE;
  mode_smooth_d = (int_4)DT_SMOOTH_NONE;
  mode_display_d = (int_4)DT_DISPLAY_NONE;

  num_of_attributes_d = (int_4)0;

  // initialize the class node, attribute list and data list
  //
  class_node_d = (Attribute_node*)NULL;
  attribute_list_d = new Linked_list;
  data_list_d = new Linked_list;
  //  data_list_d = (Linked_list*)NULL;
  
  // create instance of the tree
  //
  tree_d = new Tree();
  
  // exit gracefully
  //
}




