// file: $DT/class/decision_tree/v1.0/dt_dbg_0.cc
//

// isip include files
//
#include "decision_tree.h"

#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: debug_cc
//
// arguments:
//  FILE* fp: (input) a open file pointer
//  char_1* message: (input) identification message
//
// return: a logical_1 value indicating the status
//
logical_1 Decision_tree::debug_cc(FILE* fp_a, char_1* message_a) {

  // dump internal data
  //
  fprintf(fp_a, "<%s::%s> mode_d = %ld\n",
	  DECISION_TREE_CLASS_NAME, (char*)message_a,
	  mode_d);
  
  fprintf(fp_a, "<%s::%s> mode_split_d = %ld\n",
	  DECISION_TREE_CLASS_NAME, (char*)message_a,
	  mode_split_d);

  fprintf(fp_a, "<%s::%s> mode_prune_d = %ld\n",
	  DECISION_TREE_CLASS_NAME, (char*)message_a,
	  mode_prune_d);

  fprintf(fp_a, "%s::%s> mode_smooth_d = %ld\n",
	  DECISION_TREE_CLASS_NAME, (char*)message_a,
	  mode_smooth_d);

  if (param_fname_d == (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> param_fname_d = NULL\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a);
  }
  else {
    fprintf(fp_a, "<%s::%s> param_fname_d = %s\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a, param_fname_d);
  }

  if (attr_fname_d == (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> attr_fname_d = NULL\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a);
  }
  else {
    fprintf(fp_a, "<%s::%s> attr_fname_d = %s\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a, attr_fname_d);
  }

  if (data_fname_d == (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> data_fname_d = NULL\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a);
  }
  else {
    fprintf(fp_a, "<%s::%s> data_fname_d = %s\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a, data_fname_d);
  }
  
  if (tree_fname_d == (char_1*)NULL) {
    fprintf(fp_a, "<%s::%s> tree_fname_d = NULL\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a);
  }
  else {
    fprintf(fp_a, "<%s::%s> tree_fname_d = %s\n",
	    DECISION_TREE_CLASS_NAME, (char*)message_a, tree_fname_d);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


