// file: $DT/class/decision_tree/v1.0/dt_dnode_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>
#include <linked_list.h>
#include <string.h>
#include <data_node.h>

// method: generate_data_node_cc
//
// arguments:
//  char_1* buffer: (input) the line that's read in
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::generate_data_node_cc (char_1** data_item_a,
						int_4 num_attr) {

  // argument validity check
  //
  if (data_item_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"generate_data_node_cc",
                     (char_1*)"invalid items to generate node");
  }

  // declare useful variables
  //
  int_4 i;
  Data_node* node_a = (Data_node*)NULL;

  char_1* desc_a = new char_1[ISIP_MAX_STRING_LENGTH];  
  char_1** label_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];
  char_1** item_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];
  float_4* value_a = new float_4[DT_MAX_NUM_OF_ATTR_VALUES+3];
  
  parse_data_item_cc(data_item_a, num_attr, desc_a, label_a, item_a);
  convert_to_value_cc(num_attr, label_a, item_a, value_a);
  node_a = new Data_node(desc_a, (num_attr - 1), label_a, item_a, value_a);
  data_list_d->insert_cc((void_p)node_a);
  
  if (item_a != (char_1**)NULL) {
    for (i=0;i<num_attr-1;i++) {
      if (item_a[i] != (char_1*)NULL) {
	delete [] item_a[i];
      }
      item_a[i] = (char_1*)NULL;
    }
    delete [] item_a;
    item_a = (char_1**)NULL;
  }
  
  if (label_a != (char_1**)NULL) {
    for (i=0;i<num_attr-1;i++) {
      if (label_a[i] != (char_1*)NULL) {
	delete [] label_a[i];
      }
      label_a[i] = (char_1*)NULL;
    }
    delete [] label_a;
    label_a = (char_1**)NULL;
  }

  if (value_a != (float_4*)NULL) {
    delete [] value_a;
    value_a = (float_4*)NULL;
  }
  
  if (desc_a != (char_1*)NULL) {
    delete [] desc_a;
  }
  desc_a = (char_1*)NULL;
  
  //  auto_range_cc();
  
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


