// file: $DT/class/tree/v1.0/dt_entr_0.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "tree.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "decision_tree.h"
#include <integral_constants.h>

// method: discrete_entropoy_split_cc
//
// arguments: 
//
// return: logical_1 indicating success
//
// this method 
//
float_4 Decision_tree::discrete_entropy_split_cc(int_4* max_mask_a,
						 int_4 num_categories_a,
						 Attribute_node* attr_node_a,
						 Tree_node* node_a) {

  int_4 iter_a;
  float_4 max_a=0;
  int_4* mask_a = new int_4[num_categories_a];
  float_4 pl;                         // left node probability
  float_4 pj_l;                       // prob class j given left node
  float_4 pj_r;                       // prob class j given right node
  float_4 sum;
  float_4 delta_i;                    // twoing criterion
  int_4 num_classes_a;
  int_4* class_given_left;
  int_4* class_given_right;
  int_4 count_left=0, count_right=0;

  class_node_d->get_num_values_cc(num_classes_a);
  
  // number of possible permutations of the categories
  //
  iter_a = pow(2,(num_categories_a-1));

  // loop through all possible permutations
  //
  for ( int_4 i=1; i<iter_a; i++ ) {

    // create masks of 0,1 for each possible permutation
    //
    permute_cc(i, mask_a, num_categories_a);

    class_given_left= new int_4[num_classes_a];
    class_given_right= new int_4[num_classes_a];

    for ( int_4 j=0; j<num_classes_a; j++ ){
      class_given_left[j]=0;
      class_given_right[j]=0;
    }
    
    pl=calculate_entropy_prob_cc(mask_a,num_categories_a,attr_node_a,node_a,
				 class_given_left, class_given_right,
				 count_left, count_right);
    sum=0;

    // get the sum of the absolute values of the left node given a class
    // minus the right node given a class for all possible classes
    //
    for ( int_4 j=0; j<num_classes_a; j++ ) {
      float_4 plpr;
      if ( count_left == 0 )
	pj_l=0;
      else
	pj_l= (float_4)class_given_left[j]/(float_4)count_left;

      if ( count_right == 0 )
	pj_r=0;
      else
	pj_r=(float_4)class_given_right[j]/(float_4)count_right;
      plpr = pj_l - pj_r;
      if (plpr < 0) plpr=-plpr;
      sum+= plpr;
    }

    // compute the twoing criterion for this split
    //
    delta_i = pl*(1-pl)*(pow(sum,2))/4;

    // keep the maximum split
    //
    if ( delta_i > max_a ) {
      max_a = delta_i;
      for ( int_4 k=0; k<num_categories_a; k++ ) max_mask_a[k] = mask_a[k];
    }
  }

  delete [] mask_a;
  delete [] class_given_left;
  delete [] class_given_right;
  
  // return max value of the twoing criterion
  //
  return max_a;
}


















