// file: $DT/class/tree/v1.0/dt_entr_3.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "tree.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "decision_tree.h"
#include <integral_constants.h>

// method: discrete_entropoy_split_cc
//
// arguments: mask_a
//            num_categories_a
//            attr_node_a
//            node_a
//
// return: float_4 the probability of being in left node
//
// this method 
//
float_4 Decision_tree::calculate_entropy_prob_cc(float_4 split_a,
						 Attribute_node* attr_node_a,
						 Tree_node* node_a,
						 int_4*& class_given_left,
						 int_4*& class_given_right,
						 int_4& left_count_a,
						 int_4& right_count_a) {

  float_4 prob_a;
  int_4 num_test_cases;
  Linked_list* ll_ptr;
  Data_node* data_a;
  char_1* attr_label_a=new char_1[ISIP_MAX_STRING_LENGTH];
  float_4 data_value_a;
  char_1** attr_values_a;
  char_1* data_class_a=new char_1[ISIP_MAX_STRING_LENGTH];
  char_1** class_values_a;
  int_4 num_classes_a;
  int_4 num_values_a;

  // get data from tree node
  //
  node_a->get_num_data_nodes_cc( num_test_cases );
  node_a->get_data_nodes_cc( ll_ptr );

  // get data from attribute node
  //
  attr_node_a->get_label_cc( attr_label_a );
  attr_node_a->get_num_values_cc( num_values_a );
  attr_values_a = new char_1*[num_values_a];
  for ( int_4 i=0; i<num_values_a; i++ )
    attr_values_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
  attr_node_a->get_values_cc( attr_values_a );

  // get data from class node
  //
  class_node_d->get_num_values_cc( num_classes_a );
  class_values_a = new char_1*[num_classes_a];
  for ( int_4 i=0; i<num_classes_a; i++ )
    class_values_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
  class_node_d->get_values_cc( class_values_a );

  // determine if each test case belongs in left node split or not
  //
  for ( int_4 i=0; i<num_test_cases; i++ ) {
    data_a=(Data_node*)ll_ptr->get_node_cc();
    data_a->get_value_cc( data_value_a, attr_label_a);
    data_a->get_item_cc( data_class_a, (char_1*)"index" );

    if ( data_value_a < split_a ) {
      left_count_a++;
      int_4 k=0;
      while ( strcmp((char*)data_class_a,(char*)class_values_a[k])!=0 )
	k++;
      class_given_left[k]++;
    }
    else {
      right_count_a++;
      int_4 k=0;
      while ( strcmp((char*)data_class_a,(char*)class_values_a[k])!=0 )
	k++;
      class_given_right[k]++;
    }
  
  ll_ptr=ll_ptr->get_next_cc();
  }    

  for ( int_4 i=0; i<num_values_a; i++ )
    delete [] attr_values_a[i];

  for ( int_4 i=0; i<num_classes_a; i++ )
    delete [] class_values_a[i];

  delete [] attr_label_a;
  delete [] attr_values_a;
  delete [] data_class_a;
  delete [] class_values_a;

  // calculate the left node probability
  //
  prob_a = (float_4)left_count_a/(float_4)num_test_cases;
  
  // return probability of being in the left node
  //
  return prob_a;
}


