// file: $DT/class/decision_tree/v1.0/dt_find_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "attribute_node_constants.h"
#include <integral_constants.h>
#include <string.h>

// method: find_type_cc
//
// arguments:
//  char_1** attr_valuelist_a (input) the attribute information
//  int_4    type_a (output) the attribute type
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::find_type_cc (char_1* attr_valuelist_a,
				       int_4& type_a) {
  
  // argument validity check
  //
  if (attr_valuelist_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"find_type_cc",
		     (char_1*)"can't find type of a null pointer");
  }

  if ((strncmp ((char*)attr_valuelist_a, (char*)ATTR_TYPE_CONTINUOUS_FLAG,
		(int)ATTR_TYPE_CONTINUOUS_FLAG_LENGTH - 1)) == 0) {
    type_a = ATTR_TYPE_CONTINUOUS;
  }
  else {
    type_a = ATTR_TYPE_DISCRETE;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


