// file: $DT/class/decision_tree/v1.0/dt_load_1.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "decision_tree.h"
#include <integral_constants.h>
#include <param_file.h>

// method: load_params_cc
//
// arguments:
//  char_1* (input) pointer to a parameter file
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::load_params_cc (char_1* fname_a) {

  if (fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"load_params_cc",
		     (char_1*)"input file is not valid");
  }

  // store the parameter file name
  //
  if (param_fname_d != (char_1*)NULL) {
    error_handler_cc((char_1*)"load_params_cc",
                     (char_1*)"param_fname_d already has a value");
  }

  param_fname_d = new char_1[strlen((char*)fname_a)+1];
  strcpy ((char*)param_fname_d, (char*)fname_a);

  // create the parameter file object
  //
  Param_file pfile;

  // parse parameters
  //
  if (pfile.init_cc(fname_a) == ISIP_FALSE) {
    error_handler_cc((char_1*)"Param_file::init_cc",
		     (char_1*)"Error in parsing parameter file");
  }

  char_1** params_a = new char_1*[ISIP_MAX_STRING_LENGTH];
  char_1* value_a = new char_1[ISIP_MAX_STRING_LENGTH];
  int_4 num_params;

  // retrieve parameters
  //
  pfile.get_num_params_cc (num_params);

  // allocate memory for the parameters
  //
  for (int_4 i=0;i<num_params;i++) {
    params_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
  }
  
  pfile.get_param_names_cc (params_a);

  // store each parameter into decision tree object
  //
  for (int i=0;i<num_params;i++) {
    pfile.get_cc(value_a, params_a[i]);
    set_param_cc(params_a[i], value_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


