// file: $DT/class/decision_tree/v1.0/dt_load_2.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>
#include <attribute_node.h>
#include <attribute_node_constants.h>
#include <linked_list.h>
#include <string.h>

// method: load_attributes_cc
//
// arguments:
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::load_attributes_cc (char_1* fname_a) {

  // argument validity check
  //
  if (fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"load_attributes_cc",
                     (char_1*)"attribute file is not valid");
  }

  // error already has a attribute file
  //
  if (attr_fname_d != (char_1*)NULL) {
    error_handler_cc((char_1*)"load_attributes_cc",
		     (char_1*)"attr_fname_d already has a value");
  }
  
  if (attr_fname_d == (char_1*)NULL) {
    attr_fname_d = new char_1[strlen((char*)fname_a)+1];
    strcpy ((char*)attr_fname_d, (char*)fname_a);
  }

  // define variables
  //
  int_4 num_lines_read_a = 0;
  char_1** label_list_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+1];
  char_1** value_list_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+1];

  // load in the attributes using param file class
  //
  pre_load_attributes_cc (fname_a, num_lines_read_a,
			  label_list_a, value_list_a);

  // generate class and data nodes using the parsed values
  //
  generate_nodes_cc (num_lines_read_a, label_list_a, value_list_a);

  // clean up
  //
  if (label_list_a != (char_1**)NULL) {
    for (int_4 i=0;i<num_lines_read_a;i++) {
      if (label_list_a[i] != (char_1*)NULL) {
	delete [] label_list_a[i];
	label_list_a[i] = (char_1*)NULL;
      }
    }
    delete [] label_list_a;
    label_list_a = (char_1**)NULL;
  }

  if (value_list_a != (char_1**)NULL) {
    for (int_4 i=0;i<num_lines_read_a;i++) {
      if (value_list_a[i] != (char_1*)NULL) {
	delete [] value_list_a[i];
	value_list_a[i] = (char_1*)NULL;
      }
    }
    delete [] value_list_a;
    value_list_a = (char_1**)NULL;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


