// file: $DT/class/decision_tree/v1.0/dt_load_3.cc
//

// isip include files
//
#include "decision_tree.h"
#include <param_file.h>
#include <integral_constants.h>
#include <string.h>

// method: pre_load_attributes_cc
//
// arguments:
//  char_1* fname_a (input) attribute file name
//  int_4& num_lines_read_a (output) the number of valid lines read in
//  char_1** label_list_a (output) the list of labels read
//  char_1** value_list_a (output) the list of values read
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::pre_load_attributes_cc (char_1* fname_a,
						 int_4& num_lines_read_a,
						 char_1** label_list_a,
						 char_1** value_list_a) {

  // create parameter file to parse the attribute file
  //
  Param_file attrfile(';', ':', '#');

  // fetch the attribute file information
  //
  if (attrfile.init_cc(fname_a) == ISIP_FALSE) {
    error_handler_cc((char_1*) "pre_load_attributes_cc",
		     (char_1*) "error loading attribute file");
  }
  
  // declare useful variable and get the number of lines read
  //
  attrfile.get_num_params_cc(num_lines_read_a);

  // set values according to the number of lines read
  //
  num_of_attributes_d = num_lines_read_a - 1;
 
  // allocate memory for the attributes
  //
  for (int_4 i=0;i<num_lines_read_a;i++) {
    if (label_list_a[i] != (char_1*)NULL) {
      label_list_a[i] = (char_1*)NULL;
    }
    label_list_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
    if (value_list_a[i] != (char_1*)NULL) {
      value_list_a[i] = (char_1*)NULL;
    }
    value_list_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
  }
  
  // get the list of labels
  //
  attrfile.get_param_names_cc (label_list_a);
  
  // set the values with the labels
  //
  for (int_4 j=0;j<num_lines_read_a;j++) {
    attrfile.get_cc(value_list_a[j], label_list_a[j]);
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


