// file: $DT/class/decision_tree/v1.0/dt_load_4.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>
#include <linked_list.h>
#include <string.h>
#include <data_node.h>

// method: load_data_cc
//
// arguments:
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::load_data_cc (char_1* fname_a) {

  // argument validity check
  //
  if (fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"load_data_cc",
                     (char_1*)"data file is not valid");
  }
  /*
  // error already has a data file
  //
  if (data_fname_d != (char_1*)NULL) {
    error_handler_cc((char_1*)"load_data_cc",
                     (char_1*)"data_fname_d already has a value");
  }
  data_fname_d = new char_1[strlen((char*)fname_a)+1];
  strcpy((char*)data_fname_d, (char*)fname_a);
  */

  // open the file
  //
  FILE* fp_a = (FILE*)NULL;
  fp_a = fopen ((char*)fname_a, "r");

  // declare useful variables for the data node creation
  //
  char_1* buffer = new char_1[DT_MAX_BUFFER_SIZE];
  int_4 num_attr = 0;
  //  int_4 i;
  Data_node* node_a = (Data_node*)NULL;
  //  char_1* desc_a = new char_1[ISIP_MAX_STRING_LENGTH];  
  char_1** data_item = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];
  //  char_1** label_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];
  //  char_1** value_a = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];
  
  memset(buffer,0,DT_MAX_BUFFER_SIZE);

  // read in the file
  //
  while (fgets((char*)buffer, DT_MAX_BUFFER_SIZE, fp_a) != (char*)NULL) {

    // skip the line if no ':' is found
    //
    if (strstr((char*)buffer, (char*)":") != NULL) {

      // parse the data into <label:value>
      //
      parse_data_cc(buffer, num_attr, data_item);
      generate_data_node_cc(data_item, num_attr);

      // parse the data item into <label>:<value>
      //
      //      parse_data_item_cc(data_item, num_attr, desc_a, label_a, value_a);

      // create the data node and insert into the list
      //
      //      node_a = new Data_node(desc_a, (num_attr - 1), label_a, value_a);
      //      data_list_d->insert_cc((void_p)node_a);
    }
  }

  if (data_item != (char_1**)NULL) {
    for (int_4 i=0;i<num_attr;i++) {
      if (data_item[i] != (char_1*)NULL) {
	delete [] data_item[i];
      }
      data_item[i] = (char_1*)NULL;
    }
    delete [] data_item;
    data_item = (char_1**)NULL;
  }
  
  /*if (value_a != (char_1**)NULL) {
    for (i=0;i<num_attr-1;i++) {
      if (value_a[i] != (char_1*)NULL) {
	delete [] value_a[i];
      }
      value_a[i] = (char_1*)NULL;
    }
    delete [] value_a;
    value_a = (char_1**)NULL;
  }
  
  if (label_a != (char_1**)NULL) {
    for (i=0;i<num_attr-1;i++) {
      if (label_a[i] != (char_1*)NULL) {
	delete [] label_a[i];
      }
      label_a[i] = (char_1*)NULL;
    }
    delete [] label_a;
    label_a = (char_1**)NULL;
  }
  
  if (desc_a != (char_1*)NULL) {
    delete [] desc_a;
  }
  desc_a = (char_1*)NULL;
  */
  delete [] buffer;
  
  fclose (fp_a);
  
  //  auto_range_cc();
  
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


