// file: $DT/class/decision_tree/v1.0/dt_parse_1.cc
//

// isip include files
//
#include <decision_tree.h>
#include <decision_tree_constants.h>
#include <integral.h>
#include <integral_constants.h>
#include <string.h>

// method: parse_data_cc
//
// arguments:
//  char_1*  buffer (input) the buffer to be parsed
//  int_4&   num_attr (output) the number of items parsed
//  char_1** attr_list (output) the list of parsed items
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::parse_data_cc(char_1 *buffer_a,
				       int_4& num_attr_a,
				       char_1** attr_list_a) {


  // create temporary variable and stores into tmp_buf
  //
  char_1* tmp_buf = new char_1[DT_MAX_BUFFER_SIZE];
  strcpy ((char*)tmp_buf, (char*)buffer_a);
  char_1* tmp_buf_p = tmp_buf;
  char_1* buf_0 = tmp_buf;
  char_1* buf_1 = tmp_buf;
  num_attr_a = 0;

  // define the state when a colon is not seen in the string yet
  //
  int_4 colon = ISIP_FALSE;

  // read until end of line
  //
  while (*buf_0 != ISIP_NEWLINE) {

    // a colon is not seen
    //
    if (colon == ISIP_FALSE) {

      // ignore white spaces
      //
      if ((*buf_0 == ' ') || (*buf_0 == '\t')) {
        buf_0++;
      }
      else {

	// found a colon and set flag
	//
        if (*buf_0 == ':') {
          colon = ISIP_TRUE;
        }

        *buf_1 = *buf_0;
        buf_0++;
        buf_1++;
      }
    }
    else {

      // a colon is seen 
      //
      
      if ((*buf_0 == ' ') || (*buf_0 == '\t')) {

	// ignore whitespace if it is right after the colon
	//
        if (*(buf_1-1) == ':') {
          buf_0++;
        }
        else {

	  // found a complete valid data item
	  //
          *buf_1 = ISIP_NULL;
          buf_0++;
	  if (attr_list_a[num_attr_a] != (char_1*)NULL) {
	    attr_list_a[num_attr_a] = (char_1*)NULL;
	  }
	  
	  attr_list_a[num_attr_a] = new char_1[ISIP_MAX_STRING_LENGTH];
	  strcpy ((char*)attr_list_a[num_attr_a], (char*)tmp_buf_p);
	  num_attr_a++;
	  // printf ("%s\n", tmp_buf_p);

	  // reset state for next parse
	  //
	  tmp_buf_p = buf_0;
          buf_1 = tmp_buf_p;
          colon = ISIP_FALSE;
        }
      }
      else {

	// copy the next item
	//
        *buf_1 = *buf_0;
        buf_0++;
        buf_1++;
      }
    }
  }

  // print the last item found
  //
  if ((colon == ISIP_TRUE) && (*(buf_1-1) != ':')) {
      *buf_1 = NULL;
      if (attr_list_a[num_attr_a] != (char_1*)NULL) {
	attr_list_a[num_attr_a] = (char_1*)NULL;
      }
      attr_list_a[num_attr_a] = new char_1[ISIP_MAX_STRING_LENGTH];
      strcpy ((char*)attr_list_a[num_attr_a], (char*)tmp_buf_p);
      num_attr_a++;

      //printf ("%s\n", tmp_buf_p);

  }

  // clean up
  //
  if (tmp_buf != (char_1*)NULL) {
    delete [] tmp_buf;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
