// file: $DT/class/decision_tree/v1.0/dt_parse_2.cc
//

// isip include files
//
#include <decision_tree.h>
#include <decision_tree_constants.h>
#include <integral.h>
#include <integral_constants.h>
#include <string.h>

// method: parse_data_cc
//
// arguments:
//  char_1**  data_item_a (input) the list of all the data item
//  int_4     num_attr (input) the number of items in the data item
//  char_1*  desc_a (output) the description of the data item
//  char_1** label_a (output) the list of all data labels
//  char_1** value_a (output) the list of all data values
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::parse_data_item_cc(char_1** data_item_a,
					    int_4 num_attr,
					    char_1* desc_a,
					    char_1** label_a,
					    char_1** value_a) {


  // create temporary variable and stores into tmp_buf
  //
  int_4 i=0;
  char_1* tmp_label = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* tmp_value = new char_1[ISIP_MAX_STRING_LENGTH];
  
  // process the first item to get the description of the data item
  //
  tokenize_colon_cc(data_item_a[0], tmp_label, tmp_value);
  strcpy ((char*)desc_a, (char*)tmp_value);

  // process the rest of the items and separate them by label and
  // value
  //
  for (i=0;i<num_attr-1;i++) {
    tokenize_colon_cc(data_item_a[i+1], tmp_label, tmp_value);
    label_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
    strcpy ((char*)label_a[i], (char*)tmp_label);
    value_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
    strcpy ((char*)value_a[i], (char*)tmp_value);
  }

  // clean up
  //
  if (tmp_label != (char_1*)NULL) {
    delete [] tmp_label;
  }
  if (tmp_value != (char_1*)NULL) {
    delete [] tmp_value;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}

