// file: $DT/class/tree/v1.0/dt_prob_0.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "tree.h"
#include "decision_tree.h"
#include <integral_constants.h>

// method: permute_cc
//
// arguments: int_4  to indicate which permutation of the possible classes
//                   to return
//            int_4* masking array for splitting the variables into
//                   to superclasses, needs to be of length [num_cat_a]
//            int_4 to indicate number of different categories in the
//                   attribute
//
// return: logical_1 indicating success
//
// this method returns the binary representation of the num_a passed in
//
logical_1 Decision_tree::permute_cc( int_4 num_a, int_4* mask_a,
				     int_4 num_cat_a ) {

  int_4 index_a;
  
  // start indexing with LSB
  //
  index_a= num_cat_a-1;

  // supply binary representation of number passed in
  //
  for ( int_4 i=0; i< num_cat_a; i++ ) {
    mask_a[index_a] = num_a%2;
    num_a /=2;
    index_a--;
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
