// file: $DT/class/decision_tree/v1.0/dt_manual_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include <integral_constants.h>
#include <stdlib.h>

// method: manual_range_cc
//
// arguments:
//  char_1** attr_values_a (output) the list of attribute values
//  int_4  min_a (input) the minimum value of the range
//  int_4  max_a (input) the maximum value of the range
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::manual_range_cc (char_1** attr_values_a,
					int_4 min_a, int_4 max_a) {
  
  // argument validity check
  //
  if (min_a > max_a) {
    error_handler_cc((char_1*)"manual_range_cc",
		     (char_1*)"invalid range");
  }

  if (attr_values_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"manual_range_cc",
		     (char_1*)"no memory allocated for output values");
  }

  char_1* temp = new char_1[ISIP_MAX_STRING_LENGTH];
  
  for (int_4 i=0;i<=max_a - min_a;i++) {
    strcpy((char*)temp, "");
    attr_values_a[i] = new char_1[ISIP_MAX_STRING_LENGTH];
    strcpy((char*)attr_values_a[i],ulltostr((i+min_a), (char*)temp));
  }

  if (temp != (char_1*)NULL) {
    delete [] temp;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


