// file: $DT/class/decision_tree/v1.0/dt_set_0.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: set_param_cc
//
// arguments:
//  char_1* param: (input) parameter string
//  char_1* value: (input) value string
//
// return: a logical_1 indicating status
//
// This function sets a given parameter (param) to a value (value)
//
logical_1 Decision_tree::set_param_cc (char_1* param_a, char_1* value_a) {

  if (param_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"set_param_cc",
		     (char_1*)"invalid parameter pointer");
  }
  
  if (value_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"set_param_cc",
		     (char_1*)"invalid value to set");
  }

  if (strcmp ((char*) param_a, (char*)DT_MODE) == 0) {
    if (strcmp ((char*) value_a, (char*)DT_MODE_TEST_NAME) == 0) {
      mode_d = DT_MODE_TEST;
    }
    else if (strcmp ((char*) value_a, (char*)DT_MODE_TRAIN_NAME) == 0) {
      mode_d = DT_MODE_TRAIN;
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"invalid value for mode parameter");
    }
  }

  else if (strcmp ((char*) param_a, (char*)DT_SPLIT) == 0) {
    if (strcmp ((char*) value_a, (char*)DT_SPLIT_ENT_NAME) == 0) {
      mode_split_d = DT_SPLIT_ENT;
    }
    else if (strcmp ((char*) value_a, (char*)DT_SPLIT_BAYES_NAME) == 0) {
      mode_split_d = DT_SPLIT_BAYES;
    }
    else if (strcmp ((char*) value_a, (char*)DT_SPLIT_GAINRATIO_NAME) == 0) {
      mode_split_d = DT_SPLIT_GAINRATIO;
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"invalid splitting parameter");
    }
  }

  else if (strcmp ((char*) param_a, (char*)DT_PRUNE) == 0) {
    if (strcmp ((char*) value_a, (char*)DT_PRUNE_PESSIMISTIC_NAME) == 0) {
      mode_prune_d = DT_PRUNE_PESSIMISTIC;
    }
    else if (strcmp ((char*) value_a,
		     (char*)DT_PRUNE_COSTCOMPLEXITY_NAME) == 0) {
      mode_prune_d = DT_PRUNE_COSTCOMPLEXITY;
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"invalid pruning parameter");
    }
  }

  else if (strcmp ((char*) param_a, (char*)DT_SMOOTH) == 0) {
    if (strcmp ((char*) value_a, (char*)DT_SMOOTH_BAYES_NAME) == 0) {
      mode_smooth_d = DT_SMOOTH_BAYES;
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"invalid smoothing parameter");
    }
  }

  else if (strcmp ((char*) param_a, (char*)DT_DISPLAY) == 0) {
    if (strcmp ((char*) value_a, (char*)DT_DISPLAY_BASIC_NAME) == 0) {
      mode_display_d = DT_DISPLAY_BASIC;
    }
    else if (strcmp ((char*) value_a, (char*)DT_DISPLAY_COUNT_NAME) == 0) {
      mode_display_d = DT_DISPLAY_COUNT;
    }
    else if (strcmp ((char*) value_a, (char*)DT_DISPLAY_PROB_NAME) == 0) {
      mode_display_d = DT_DISPLAY_PROB;
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"invalid display parameter");
    }
  }

  else if (strcmp ((char*) param_a, (char*)DT_TREE_FILENAME) == 0) {
    if (tree_fname_d == (char_1*)NULL) {
      tree_fname_d = new char_1[strlen(value_a)+1];
      strcpy ((char*)tree_fname_d, (char*)value_a);
    }
    else {
      error_handler_cc((char_1*)"set_param_cc",
		       (char_1*)"can't define the tree file more than once");
    }
  }

  else {
    error_handler_cc((char_1*)"set_param_cc",
		     (char_1*)"invalid parameter to set");
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


