// file: $DT/class/tree/v1.0/dt_split_0.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "tree.h"
#include "decision_tree.h"
#include <integral_constants.h>

// method: split_cc
//
// arguments: 
//
// return: logical_1 flag to indicate success
//
// this method grows a tree using the twoing rule
//
logical_1 Decision_tree::split_cc(int_4 dt_split_a,
				  Tree_node* node_a=(Tree_node*)NULL) {

  logical_1 can_split;

  // determine if this is the first node
  //
  if ( node_a == (Tree_node*)NULL ) {
    Tree_node* root_a = new Tree_node();
    tree_d->insert_cc( root_a,node_a );  

    // add linked list of data node pointers
    //
    Linked_list* ll_data=data_list_d;
    Data_node* data_a;
    while ( ll_data ) {
      data_a=(Data_node*)ll_data->get_node_cc();
      root_a->add_data_node_cc(data_a);
      ll_data=ll_data->get_next_cc();
    }

    node_a = tree_d->get_root_cc();
  }
  
  // determine if a split is possible at this node
  //
  can_split= not_pure_cc(node_a);

  // split the data at this node if the data can be split
  //
  if ( can_split ) {

    // create the children of the current node
    //
    Tree_node* left_child= new Tree_node();
    Tree_node* right_child= new Tree_node();

    // find best split at this node
    //
    if (best_split_cc( dt_split_a, node_a , left_child, right_child)
	== ISIP_TRUE) {

      // recursively find the left hand splits
      //
      split_cc( dt_split_a, left_child );
      
      // recursively find the right hand splits
      //
      split_cc( dt_split_a, right_child );
    }
    else {
      delete left_child;
      delete right_child;
    }
  }
    
  // exit gracefully
  //
  return ISIP_TRUE;
}
