// file: $DT/class/tree/v1.0/dt_split_4.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree.h"    
#include "decision_tree.h"
#include "decision_tree_constants.h"

// systme include files
//
#include <strings.h>
#include <integral_constants.h>

// method: classify_data_node_cc
//
// arguments: int_4* mask_a  mask for the discrete values
//            attr_node_a  attribute where the split occurs
//            data_a data node that is to be classified
//
// return: int_4 DT_SPLIT_LEFT or DT_SPLIT_RIGHT indicating which way
// the data should go
//
// this method determines if this data node goes into the left or right
// child node
//
int_4 Decision_tree::classify_data_node_cc(int_4* mask_a,
					   Attribute_node* attr_node_a,
					   Data_node* data_a) {

  int_4 num_values_a;
  logical_1 attr_found;
  char_1* value_a= new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* attr_name_a= new char_1[ISIP_MAX_STRING_LENGTH];
  char_1** attr_values_a;
  char_1* attr_single_value_a= new char_1[ISIP_MAX_STRING_LENGTH];
  int_4 mask_index;

  // get length of the mask
  //
  attr_node_a->get_num_values_cc(num_values_a);

  // allocate space
  //
  attr_values_a = new char_1*[num_values_a];
  for ( int_4 i=0; i< num_values_a; i++ )
    attr_values_a[i]=new char_1[ISIP_MAX_STRING_LENGTH];

  // get list of possible attribute values
  //
  attr_node_a->get_values_cc(attr_values_a);

  // get the labels from the attribute node
  //
  attr_node_a->get_label_cc(attr_name_a);
  attr_found=data_a->get_item_cc( value_a , attr_name_a );

  if ( !attr_found )
    error_handler_cc((char_1*)"classify data_node_cc",
		     (char_1*)" could not find attribute");

  // determine if, for the specified attribute, the value belongs with
  // the category masked by a zero or masked by a one
  //
  for ( mask_index=0; mask_index<num_values_a; mask_index++ ) {
    attr_single_value_a=attr_values_a[mask_index];
    if ( strcmp((char*)attr_single_value_a,(char*)value_a) == 0) break;
  }

  for ( int_4 i=0; i<num_values_a; i++ )
    delete [] attr_values_a[i];
  delete [] attr_values_a;

  delete [] value_a;
  delete [] attr_name_a;
  delete [] attr_single_value_a;
  
  // return the direction of the split
  //
  if ( mask_a[mask_index] == 0 )
    return DT_SPLIT_LEFT;
  else
    return DT_SPLIT_RIGHT;
  
}



