// file: $DT/class/tree/v1.0/dt_split_5.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree.h"    
#include "decision_tree.h"
#include "decision_tree_constants.h"

// systme include files
//
#include <integral_constants.h>

// method: classify_data_node_cc
//
// arguments: float_4 indicating where to split
//            attr_node_a  attribute where the split occurs
//            data_a data node that is to be classified
//
// return: int_4 DT_SPLIT_LEFT or DT_SPLIT_RIGHT indicating which way
// the data should go
//
// this method determines if this data node goes into the left or right
// child node
//
int_4 Decision_tree::classify_data_node_cc(float_4 split_a,
					   Attribute_node* attr_node_a,
					   Data_node* data_a) {

  logical_1 attr_found;
  float_4 value_a;
  char_1* attr_name_a = new char_1[ISIP_MAX_STRING_LENGTH];

  // get the labels from the attribute node
  //
  attr_node_a->get_label_cc(attr_name_a);
  attr_found=data_a->get_value_cc( value_a, attr_name_a );

  if ( !attr_found )
    error_handler_cc((char_1*)"classify data_node_cc",
		     (char_1*)" could not find attribute");

  delete [] attr_name_a;
  
  // return the direction of the split
  //
  if ( value_a < split_a )
    return DT_SPLIT_LEFT;
  else
    return DT_SPLIT_RIGHT;
  
}






