// file: $DT/class/tree/v1.0/dt_split_6.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree.h"    
#include "decision_tree.h"
#include "decision_tree_constants.h"

// systme include files
//
#include <integral_constants.h>

// method: not_pure_cc
//
// arguments: float_4 indicating where to split
//            attr_node_a  attribute where the split occurs
//            data_a data node that is to be classified
//
// return: ISIP_TRUE if the node is not pure
//         ISIP_FALSE if the node is pure
//
// this method determines if there is only one class type in this node
// the node is considered pure when only one class exists at that node
//
logical_1 Decision_tree::not_pure_cc( Tree_node* node_a ) {

  Linked_list* ll_ptr;
  Data_node* data_a;
  char_1* class_name_1=new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* class_name_2=(char_1*)NULL;
  logical_1 not_pure=ISIP_FALSE;
  
  // get the linked list of data node pointers at this node
  //
  node_a->get_data_nodes_cc(ll_ptr);

  // go thru each data node
  //
  while ( ll_ptr ) {

    // get the class of this data node
    //
    data_a=(Data_node*)ll_ptr->get_node_cc();
    data_a->get_item_cc(class_name_1,(char_1*)"index");

    if ( class_name_2 == (char_1*)NULL ) {
      class_name_2=new char_1[ISIP_MAX_STRING_LENGTH];
      strcpy((char*)class_name_2,(char*)class_name_1);
    }

    // if the previous classification is not the same as the present
    // classification, then the node is not pure
    //
    if ( strcmp((char*)class_name_1,(char*)class_name_2) != 0 ) {
      not_pure=ISIP_TRUE;
      break;
    }

    ll_ptr=ll_ptr->get_next_cc();
  }

  if ( class_name_1 != (char_1*)NULL )
    delete [] class_name_1;
  if ( class_name_2 != (char_1*)NULL )
    delete [] class_name_2;
  
  // return logical_1 indicating if node not pure
  //
  return not_pure;

}

