// file: $DT/class/decision_tree/v1.0/dt_srch_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <attribute_node.h>
#include <attribute_node_constants.h>
#include <linked_list.h>
#include <string.h>
#include <integral_constants.h>

// method: search_attribute_cc
//
// arguments:
//  char_1* label (input): the string label to look for
//  Attribute_node* node (output): a pointer to the attribute node with
//                                 this label
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::search_attribute_cc(char_1* label_a,
					     Attribute_node* node_a) {

  // validity checks
  //
  if (label_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"search_attribute_cc",
		     (char_1*)"no label given");
  }

  Linked_list* ll = attribute_list_d;
  char_1* attr_label;
  
  while (ll != (Linked_list*)NULL) {
    Attribute_node* temp_node = (Attribute_node*)(ll->get_node_cc());
    temp_node->get_label_cc(attr_label);

    if (strcmp((char*)attr_label, (char*)label_a) == 0) {
      node_a = temp_node;
      return ISIP_TRUE;
    }

    ll = ll->get_next_cc();
  }

  // exit ungracefully
  //
  return ISIP_FALSE;
}


