// file: $DT/class/decision_tree/v1.0/dt_token_1.cc
//

// isip include files
//
#include "decision_tree.h"
#include <integral_constants.h>
#include <param_file.h>

// method: tokenize_colon_cc
//
// arguments:
//  char_1*  buffer_a (input) buffer to be tokenized
//  char_1*  label_a (output) label of the attribute
//  char_1** attr_values_a (output) a string of attribute values to return
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::tokenize_colon_cc (char_1* buffer_a,
					    char_1* label_a,
					    char_1* attr_valuelist_a) {
  
  // argument validity check
  //
  if (buffer_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"tokenize_values_cc",
		     (char_1*)"can't tokenize an empty string");
  }
				 
  if (label_a == (char_1*)NULL) {
        error_handler_cc((char_1*)"tokenize_values_cc",
                     (char_1*)"invalid output location");
  }

  if (attr_valuelist_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"tokenize_values_cc",
                     (char_1*)"invalid output location");
  }
  
  sscanf ((char*)buffer_a, "%[^:]:%s", (char*)label_a,
	  (char*)attr_valuelist_a);
  if (*(attr_valuelist_a + strlen((char*)attr_valuelist_a)-1) == '.') {
    *(attr_valuelist_a + strlen((char*)attr_valuelist_a)-1) = '\0';
  }
  else {
    *(attr_valuelist_a + strlen((char*)attr_valuelist_a)) = '\0';
  }
 
  // exit gracefully
  //
  return ISIP_TRUE;
}


