// file: linked_list.h
//

// make sure definitions are made only once
//
#ifndef __ISIP_LINKED_LIST
#define __ISIP_LINKED_LIST

// isip include files
//
#include <integral.h>

// Linked_list
//
// this file defines a class that implements a general bidirectional
// linked list
//
class Linked_list {
  
  //---------------------------------------------------------------------------
  //
  // protected data
  //
  //---------------------------------------------------------------------------
protected:

  // linked list node
  //
  void_p node_d;

  // link pointers
  //
  Linked_list* next_d;
  Linked_list* prev_d;

  // position pointer
  //
  Linked_list* curr_d;

  // debug parameters
  //
  int_4 debug_level_d;
  
  //---------------------------------------------------------------------------
  //
  // public methods
  //
  //---------------------------------------------------------------------------
public:

  // required methods
  //
  char_1* name_cc();
  volatile void error_handler_cc(char_1* mname, char_1* msg);
  logical_1 debug_cc(FILE* fp, char_1* message);
  logical_1 set_debug_cc(int_4 value);
  
  // destructors/constructors
  //
  ~Linked_list();
  Linked_list(void_p node=NULL);
  Linked_list(Linked_list &list);

  // set the current position to specified node
  //
  logical_1 set_current_cc(Linked_list* link);
  logical_1 set_current_cc(void_p node);
  Linked_list* get_current_cc();

  // method to set node
  //
  logical_1 set_node_cc(void_p node);

  // methods to get nodes
  //
  void_p get_node_cc();
  void_p get_curr_node_cc();

  // methods to set links
  //
  logical_1 set_prev_cc(Linked_list* link);
  logical_1 set_next_cc(Linked_list* link);

  // methods to get links
  //
  Linked_list* get_prev_cc();
  Linked_list* get_next_cc();
  
  // linked list modification methods
  //
  logical_1 insert_cc(void_p node);
  logical_1 delete_cc(void_p node);
  logical_1 merge_cc(void_p node1, void_p node2);
  logical_1 split_cc(void_p node);
};

// end of include file
//
#endif
