// file: ll_curr_0.cc
//

// isip include files
//
#include "linked_list.h"
#include <integral_constants.h>
 
// method: set_current_cc
//
// arguments:
//  void_p node: (input) the node to be set as current
//
// return: a logical flag indicating success
//
// this method sets the current pointer to the given node
//
logical_1 Linked_list::set_current_cc(void_p node_a) {

  // temporary variable
  //
  Linked_list* link = curr_d;

  // check if this is a valid node
  //
  while (link->node_d != node_a) {
    
    // move ahead in the list
    //
    link = link->next_d;

    // look in the opposite direction if this node isn't found
    //
    if (link == NULL) {
      link = curr_d->prev_d;
  
      while (link->node_d != node_a) {
	
	// move backwards in the list
	//
	link = link->prev_d;

	// quit if this node doesn't exist
	//
	if (link == NULL) {
	  error_handler_cc((char_1*)"set_current_cc",
			   (char_1*)"specified node does not exist in list");

	  // exit ungracefully
	  //
	  return ISIP_FALSE;
	}
      }
    }
  }

  // set this as current node
  //
  for (Linked_list* ll = this; ll != NULL; ll = ll->next_d) {
    ll->curr_d = link;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;	
}
