// file: ll_link_0.cc
//

// isip include files
//
#include "linked_list.h"
#include <integral_constants.h>

// method: insert_cc
//
// arguments:
//  void_p node: (input) the node to be inserted in the list
//
// return: a logical flag indicating success
//
// this method inserts the given node in the list at the current
// position
//
logical_1 Linked_list::insert_cc(void_p node_a) {

  // if there is space at the head of the list put data here
  //
  if (node_d == NULL) {
    node_d = node_a;
    curr_d = this;
  }
  
  // otherwise insert data after the current position
  //
  else {
    
    // create a new link
    //
    Linked_list* link = new Linked_list(node_a);

    // insert it in the right place
    //
    link->prev_d = curr_d;
    link->next_d = curr_d->next_d;
    if (curr_d->next_d != NULL) {
      curr_d->next_d->prev_d = link;
    }
    curr_d->next_d = link;
	
    // make current node point to the new node
    //
    curr_d = curr_d->next_d;
  }
  
  // set the current node
  //
  for (Linked_list* ll = this; ll != NULL; ll = ll->next_d) {
    ll->curr_d = curr_d;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
