// file: ll_link_1.cc
//

// isip include files
//
#include "linked_list.h"
#include <integral_constants.h>

// method: delete_cc
//
// arguments:
//  void_p node: (input) the utterance to be deleted from the list
//
// return: a logical value to indicate success
//
// this method deletes the link corresponding to the specified node
// from the linked list
//
logical_1 Linked_list::delete_cc(void_p node_a) {

  // set the current link to the specified node
  //
  set_current_cc(node_a);

  // get the previous and next links for this
  //
  Linked_list* prev = curr_d->prev_d;
  Linked_list* next = curr_d->next_d;

  // connect the two links directly
  //
  if (prev != NULL) {
    prev->next_d = next;
    curr_d->prev_d = NULL;
  }
  if (next != NULL) {
    next->prev_d = prev;
    curr_d->next_d = NULL;
  }
  
  // delete this node and make the new node the current node
  //
  if (curr_d == this) {
    delete node_d;
    Linked_list* ll = this;
    while (ll->next_d != NULL) {
      ll->node_d = ll->next_d->node_d;
      ll = ll->next_d;
    }
    ll->node_d = NULL;
    delete ll;
  }
  else {
    delete curr_d;
    curr_d = prev;
  }
  
  // set this as current node
  //
  for (Linked_list* ll = this; ll != NULL; ll = ll->next_d) {
    ll->curr_d = curr_d;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
