// file: ll_link_1.cc
//

// isip include files
//
#include "linked_list.h"
#include <integral_constants.h>

// method: merge_cc
//
// arguments:
//  void_p node1: (input) the first node to be merged
//  void_p node2: (input) the last node to be merged
//
// return: a logical_1 flag to indicate success
//
// this method deletes the specified range of node links from the list
// and replaces them with a single link. the current pointer is set to
// this new link.
//
logical_1 Linked_list::merge_cc(void_p node1_a, void_p node2_a) {

  // set the current link to pint to the first node
  //
  set_current_cc(node1_a);

  // create a new link with the same node
  //
  Linked_list* link = new Linked_list(node1_a);

  // set the next link for the new link
  //
  set_current_cc(node2_a);
  link->next_d = curr_d->next_d;
  curr_d->next_d->prev_d = link;
  curr_d->next_d = NULL;

  // set the previous link for the new link
  //
  set_current_cc(node1_a);
  link->prev_d = curr_d->prev_d;
  curr_d->prev_d->next_d = link;
  curr_d->prev_d = NULL;
  
  // delete the intermediate links
  //
  curr_d->node_d = NULL;
  delete curr_d;

  // reset the current link
  //
  for (Linked_list* ll = this; ll != NULL; ll = ll->next_d) {
    ll->curr_d = link;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
