// file: $DT/class/param_file/v1.0/pfil_token_0.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "param_file.h"
#include "param_file_constants.h"
#include <integral_constants.h>

// method: get_cc
//
// arguments:
//  char_1** param_list: (output) array of all the parameters
//  int_4& num_of_params: (output) number of parameters read
//
// return: logical error status
//
// This function tokenizes a string into an array of strings
//
logical_1 Param_file::get_param_names_cc(char_1** param_list_a) {

  // make sure memory is allocated for the parameter list
  //
  if (param_list_a == (char_1**)NULL) {
    error_handler_cc ((char_1*) "get_param_names_cc",
		      (char_1*) "output memory is not allocated");
  }
  
  // loop through to copy parameter list over
  //
  for (int_4 i=0;i<num_params_d;i++) {
    if (param_list_a[i] == (char_1*)NULL) {
      error_handler_cc ((char_1*) "get_param_names_cc",
			(char_1*) "output memory is not allocated");
    }
    strcpy ((char*)param_list_a[i], (char*)params_d[i]);
  }

  // exit gracefully
  //
  return ISIP_TRUE;  
}



