// file: $DT/class/param_file/v1.0/pfil_set_0.cc
//

// system include files
//
#include <stdlib.h>
#include <string.h>

// isip include files
//
#include "param_file.h"

#include "param_file_constants.h"
#include <integral_constants.h>

// method: set_cc
//
// arguments:
//  char_1* param: (input) parameter string
//  char_1* value: (input) value string
//
// return: logical error status
//
// This function sets a given parameter (param) to the value in value string
//
logical_1 Param_file::set_cc(char_1* param_a, char_1* value_a) {
  
  //  if (args null) error;
  
  if (num_params_d >= PFIL_MAX_NUM_PARAMS) {
    error_handler_cc((char_1*)"set_cc",
		     (char_1*)"too many paramaters");
    return ISIP_FALSE;
  }

  if (num_params_d == 0) {
    if (params_d == (char_1**)NULL) {
      params_d = new char_1*[PFIL_MAX_NUM_PARAMS];
    }
    if (values_d == (char_1**)NULL) {
      values_d = new char_1*[PFIL_MAX_NUM_PARAMS];
    }
  } else {
    if ((params_d == (char_1**)NULL) || (values_d == (char_1**)NULL)) {
      error_handler_cc((char_1*)"set_cc",
		       (char_1*)"arrays not declared, but they should be");
      return ISIP_FALSE;
    }
  }
  
  // might want to make a uniqness check???
  //

  if (params_d[num_params_d] == (char_1*)NULL) {
    params_d[num_params_d] = new char_1[strlen((char*)param_a)+1];
  }
  strcpy((char*)params_d[num_params_d],(char*)param_a);
	 
  if (values_d[num_params_d] == (char_1*)NULL) {
    values_d[num_params_d] = new char_1[strlen((char*)value_a)+1];
  }
  strcpy((char*)values_d[num_params_d],(char*)value_a) ;

  num_params_d ++;
  
  // exit gracefully
  //
  return ISIP_TRUE;  
}
