// file: $DT/class/tree/v1.0/tree_io_0.cc
//

// isip include files
//
#include <tree.h>
#include "tree_constants.h"
#include <string.h>
#include <integral_constants.h>

// forward class definitions
//
#include <tree_node.h>

// method: output_tree_cc
//
// arguments: file pointer
//            Tree_node* points to starting tree node
//            int_4 count_a keeps track of the level on in the tree
//               when called with the root of the tree, the level
//               should be zero.
//    
// return: logical_1 indicating success
//
// this method outputs the contents of the tree to a file
//
logical_1 Tree::output_tree_cc(FILE* fp_a, Tree_node* current_a,
			       int_4 display_level_a) {

  Linked_list* child_a;
  char_1* output_str_a;

  if (fp_a == (FILE*)NULL) {
    error_handler_cc((char_1*)"output_tree_cc",
		     (char_1*)"no file opened");
    return ISIP_FALSE;
  }

  // make sure tree exists
  //
  if (current_a != NULL) {
    // get the question at the root
    //
    // do nothing
    if ( current_a == root_d ) {
      //      output_str_a = current_a->get_contents_cc(display_level_a);
      //      fprintf(fp_a,"%s\n",(char*)output_str_a);
    }

    // get the children of the node
    //
    child_a = current_a->get_children_cc();
      
    // get the tree node
    //
    if ( child_a != NULL ) {
      current_a = (Tree_node*)child_a->get_node_cc();
    }
    else {
      current_a = NULL;
    }
    
    // recursively output the question at each node
    //
    while (current_a != NULL) {
	  
      // output the question at the node
      //
      output_str_a = current_a->get_contents_cc(display_level_a);
 
      // output question to file
      //
      fprintf(fp_a,"%s\n",(char*)output_str_a);

      // recursively get each child node
      //
      output_tree_cc(fp_a, current_a, display_level_a);
      
      // go to the next child in the node
      //
      child_a = child_a->get_next_cc();
      
      // get the tree node
      //
      if ( child_a != NULL ) {
	current_a = (Tree_node*)child_a->get_node_cc();
      }
      else {
	current_a = NULL;
      }
    }
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
