// file: $DT/class/tree/v1.0/tree_io_1.cc
//

// isip include files
//
#include <tree.h>
#include "tree_constants.h"
#include <decision_tree_constants.h>
#include <string.h>
#include <integral_constants.h>

// forward class definitions
//
#include <tree_node.h>

// method: output_tree_cc
//
// arguments: file pointer
//            int_4 display level shows what type of tree to output
//    
// return: logical_1 indicating success
//
// this method outputs the contents of the tree to a file
//
logical_1 Tree::output_tree_cc(FILE* fp_a, int_4 display_level_a) {

  if (fp_a == (FILE*)NULL) {
    error_handler_cc((char_1*)"output_tree_cc",
		     (char_1*)"no file opened");
    return ISIP_FALSE;
  }

  // display basic tree
  //
  if (display_level_a == DT_DISPLAY_BASIC) {
    output_tree_cc(fp_a, root_d);
  }

  // display count tree
  //
  else if (display_level_a == DT_DISPLAY_COUNT) {
    output_tree_cc(fp_a, root_d, DT_DISPLAY_COUNT);
  }

  // display probability tree
  //
  else if (display_level_a == DT_DISPLAY_PROB) {
    output_tree_cc(fp_a, root_d, DT_DISPLAY_PROB);
  }

  return ISIP_TRUE;
}
