// file: $DT/class/tree/v1.0/tree_oper_0.cc
//

// isip include files
//
#include "tree.h"
#include <integral_constants.h>

// method: insert_cc
//
// arguments: Tree_node* parent_a  parent to node getting inserted
//
// return: logical_1 flag to indicate success
//
// this method inserts a node into the tree at a specified location
// the node must already be created
//
logical_1 Tree::insert_cc(Tree_node* new_node_a, Tree_node* parent_a) {

  int_4 level_a;

  // check to see if node added is to be the root
  //
  if (parent_a == NULL) {
    if ( root_d != NULL) {
      delete root_d;
    }
    root_d = new_node_a;
    root_d->set_level_cc(0);
  }

  // otherwise add node as child to specified parent
  //
  else {
    parent_a->add_child_cc( new_node_a );
    level_a = parent_a->get_level_cc();
    new_node_a->set_level_cc( level_a+1 );
  }

  // set cuurent node pointer to node just added
  //
  current_d=new_node_a;

  // set parent node pointer in the node just inserted
  //
  new_node_a->set_parent_cc( parent_a );
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
