// file: $DT/class/tree/v1.0/tree_oper_1.cc
//

// isip include files
//
#include "tree.h"
#include <integral_constants.h>

// method: delete_cc
//
// arguments: Tree_node* node_a  node to be deleted
//
// return: logical_1 flag to indicate success
//
// this method deletes a specified tree node
//
logical_1 Tree::delete_cc(Tree_node* node_a) {

  Tree_node* parent_a;
  Linked_list* children_a;

  // check to see if node to be deleted is the root
  //
  if ( node_a == root_d ) {
    root_d = NULL;
    delete(node_a);
  }
  else {
    // get the parent of the node to be deleted
    //
    parent_a = node_a->get_parent_cc();

    // get the linked list of children from this parent
    //
    children_a = parent_a->get_children_cc();

    // delete the specified node from the linked list of children
    //
    children_a->delete_cc((void_p)node_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
