// file: $DT/class/tree/v1.0/tree_oper_4.cc
//

// isip include files
//
#include "tree.h"
#include "linked_list.h"
#include "tree_node.h"
#include <integral_constants.h>

// method: number_terminal_nodes_cc
//
// arguments: none
//
// return: number of terminal nodes
//
// this method determines the number of terminal nodes this tree has
//
int_4 Tree::number_terminal_nodes_cc(int_4 terminal_a, Tree_node* current_a) {

  Linked_list* child_a;
  logical_1 stay_in_loop=ISIP_TRUE;
  
  if ( !current_a->is_terminal_cc() ) {
    
    // get the children of the node
    //
    child_a = current_a->get_children_cc();
    
    // get the first child node
    //
    current_a = (Tree_node*)child_a->get_node_cc();
    
    // recursively count the terminal nodes
    //
    while ( stay_in_loop ) {
      
      // recursively get each child node
      //
      terminal_a=number_terminal_nodes_cc(terminal_a,current_a);
      
      // go to the next child in the node
      //
      child_a = child_a->get_next_cc();
      
      // get the tree node
      //
      if ( child_a != (Linked_list*)NULL ) {
	current_a = (Tree_node*)child_a->get_node_cc();
      }
      else {
	stay_in_loop=ISIP_FALSE;
      }
    }
  }
  else {
    // increment the terminal node count
    //
    terminal_a+=1;
  }
  
  terminal_d = terminal_a;
  
  // return the terminal node count
  //
  return terminal_d;
}
