// file: $DT/class/tree/v1.0/tree_overload_0.cc
//

// isip include files
//
#include "tree.h"
#include "tree_constants.h"

// method: overloaded operator =
//
// arguments: tree to be copied
//
// return: copy of Tree
//
// this is the overloaded operator = for the tree class
//
Tree& Tree:: operator=( const Tree& old_tree ) {

   // pointer to the root of the tree
  //
  Tree_node* node_a = old_tree.root_d;

  // copy old root node into current tree's root node
  // all other nodes will be automatically copied because of the
  // copy constructor of the tree node
  //
  root_d = new Tree_node(*node_a);
  
  // return gracefully
  //
  return *this;

}
