// file: $DT/class/tree_node/v1.0/tn_cstr_0.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"

// method: destructor
//
// arguments: none
//
// return: none
//
// this is the default destructor for the Tree_node class
//
Tree_node::~Tree_node() {

  // delete the children nodes
  //
  if (children_d != NULL) {

    Linked_list* ll_temp = children_d;
    Tree_node* tn_temp;

    // delete the nodes contained in the link list
    //
    while ( ll_temp != (Linked_list*)NULL ) {
      tn_temp = (Tree_node*)ll_temp->get_node_cc();
      if ( tn_temp != (Tree_node*)NULL )
	delete tn_temp;
      ll_temp = ll_temp->get_next_cc();
    }

    // delete the linked list
    //
    delete children_d;
  }

  // delete the linked list of data nodes
  //
  if (data_d != NULL) {
    delete data_d;
  }
  
  // delete the data contained in the node
  //
  if (question_d != (char_1*)NULL ) {
    delete question_d;
  }
  if (label_d != (char_1*)NULL ) {
    delete label_d;
  }
  if ( output_d != (char_1*)NULL ) {
    delete output_d;
  }
  if ( count_d != (int_4*)NULL ) {
    delete [] count_d;
  }
  if ( probability_d != (float_4*)NULL ) {
    delete [] probability_d;
  }

  if ( discrete_values_d != (char_1**)NULL ) {
    for ( int_4 i=0; i<num_discrete_values_d; i++ )
      delete [] discrete_values_d[i];
    delete [] discrete_values_d;
  }

  if ( classes_d != (char_1**)NULL ) {
    for ( int_4 i=0; i<num_class_d; i++ )
      delete [] classes_d[i];
    delete [] classes_d;
  }

  // exit gracefully
  //
}


