// file: $DT/class/tree_node/v1.0/tn_cstr_2.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"

// include system files
//
#include <string.h>

// method: constructor
//
// arguments: float_4 min_a    minimum number in range
//            float_4 max_a    maximum number in range
//            int_4 operator_d operator used for question
//            char_1* attr_label_a  attribute label
//
// return: none
//
// this is the constructor for the Tree_node class sets the node as
// it is created
//
Tree_node::Tree_node(float_4 min_a, float_4 max_a, int_4 operator_a,
		     char_1* attr_label_a) {

  // set protected data equal to data passed in
  //
  min_d = min_a;
  max_d = max_a;
  operator_d = operator_a;
  label_d = new char_1[ISIP_MAX_STRING_LENGTH];
  strcpy((char*)label_d, (char*)attr_label_a);

  // initialize node parameters
  //
  question_d = (char_1*)NULL;
  output_d = (char_1*)NULL;
  children_d = new Linked_list();
  probability_d = (float_4*)NULL;
  count_d = (int_4*)NULL;
  discrete_values_d = (char_1**)NULL;
  classes_d = (char_1**)NULL;
  num_class_d=0;
  level_d=0;
  data_d = new Linked_list();
  num_data_nodes_d=0;
  split_type_d = TREE_NODE_CONTINUOUS;
  
  // debugging parameters
  //
  debug_level_d = ISIP_DEBUG_NONE;
  
  // exit gracefully
  //
}

