// file: $DT/class/tree_node/v1.0/tn_cstr_4.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"

// library include files
//
#include <strings.h>

// method: copy constructor
//
// arguments: Tree_node class
//
// return: none
//
// this is the copy constructor for the Tree_node class
//
Tree_node::Tree_node( const Tree_node& old_node ) {

  Linked_list* ll_ptr;
  Tree_node* node_a;
  Data_node* node2_a;
  
  // create new space for strings if they exist, otherwise set to NULL
  //
  if ( old_node.label_d != (char_1*)NULL ) {
    label_d=new char_1[strlen((char*)old_node.label_d)];
    strcpy((char*)label_d,(char*)old_node.label_d);
  }
  else {
    label_d= (char_1*)NULL;
  }
  
  if ( old_node.question_d != (char_1*)NULL ) {
    question_d=new char_1[strlen((char*)old_node.question_d)];
    strcpy((char*)question_d,(char*)old_node.question_d);
  }
  else {
    question_d= (char_1*)NULL;
  }

  if ( old_node.output_d != (char_1*)NULL ) {
    output_d=new char_1[strlen((char*)old_node.output_d)];
    strcpy((char*)output_d,(char*)old_node.output_d);
  }
  else {
    output_d= (char_1*)NULL;
  }

  // copy linked list
  //
  children_d = new Linked_list();
  ll_ptr=old_node.children_d;
  node_a = (Tree_node*)ll_ptr->get_node_cc();
  while ( node_a != (Tree_node*)NULL ) {
    Tree_node* new_node = new Tree_node(*node_a);
    children_d->insert_cc(new_node);
    ll_ptr = ll_ptr->get_next_cc();
    node_a = (Tree_node*)ll_ptr->get_node_cc();
  }

  // copy data node linked list
  //
  data_d = new Linked_list();
  ll_ptr=old_node.data_d;
  node2_a = (Data_node*)ll_ptr->get_node_cc();
  while ( node2_a != (Data_node*)NULL ) {
    Data_node* new_node = node2_a;
    data_d->insert_cc(new_node);
    ll_ptr = ll_ptr->get_next_cc();
    node2_a = (Data_node*)ll_ptr->get_node_cc();
  }
  
  num_discrete_values_d=old_node.num_discrete_values_d;
  discrete_values_d = (char_1**)NULL;
  // allocate space for the discrete values
  //
  if ( num_discrete_values_d )
    discrete_values_d = new char_1*[num_discrete_values_d];
  for ( int_4 i=0; i<num_discrete_values_d; i++ ) {
    discrete_values_d[i]=new char_1[ISIP_MAX_STRING_LENGTH];
    strcpy((char*)*discrete_values_d[i],(char*)*old_node.discrete_values_d[i]);
  }

  num_class_d=old_node.num_class_d;
  classes_d = (char_1**)NULL;
  // allocate space for the discrete values
  //
  if ( num_class_d ) 
    classes_d = new char_1*[num_class_d];
  for ( int_4 i=0; i<num_class_d; i++ ) {
    classes_d[i]=new char_1[ISIP_MAX_STRING_LENGTH];
    strcpy((char*)*classes_d[i],(char*)*old_node.classes_d[i]);
  }
  
  level_d = old_node.level_d;
  num_data_nodes_d = old_node.num_data_nodes_d;

  // if these arrays exist, copy into new data, otherwise set to NULL
  //
  if (probability_d != (float_4*)NULL) {
    for ( int_4 i=0; i<num_class_d; i++ )
      probability_d[i]=old_node.probability_d[i];
  }
  if (count_d != (int_4*)NULL) {
    for ( int_4 i=0; i<num_class_d; i++ )
      count_d[i]=old_node.count_d[i];
  }

  // debugging parameters
  //
  debug_level_d = ISIP_DEBUG_NONE;
  
  // exit gracefully
  //
}
