// file: $DT/class/tree_node/v1.0/tn_get_0.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include <strings.h>
#include <integral_constants.h>

// method: get_question_cc
//
// arguments: none
//
// return: string containing the qustion at the node
//
// this method returns the question asked at the node in string form
//
char_1* Tree_node::get_question_cc() {

  char_1* oper_a;

  // make sure question does not already exist
  //
  if (question_d != (char_1*)NULL) {
    delete [] question_d;
  }

  // allocate memory for the question
  //
  question_d = new char_1[ISIP_MAX_STRING_LENGTH];
  
  // determine operator specified and set operator string
  //
  switch (operator_d) {
  case TREE_NODE_GT:
    oper_a = TREE_NODE_GT_STR;
    break;
  case TREE_NODE_LT:
    oper_a = TREE_NODE_LT_STR;
    break;
  case TREE_NODE_GTE:
    oper_a = TREE_NODE_GTE_STR;
    break;
  case TREE_NODE_LTE:
    oper_a = TREE_NODE_LTE_STR;
    break;
  case TREE_NODE_EQ:
    oper_a = TREE_NODE_EQ_STR;
    break;
  case TREE_NODE_RANGE_INCLUSIVE:
    oper_a = TREE_NODE_LTE_STR;
    break;
  case TREE_NODE_RANGE_EXCLUSIVE:
    oper_a = TREE_NODE_LT_STR;
    break;
  default:
    oper_a = (char_1*)NULL;
  }

  if ( split_type_d == TREE_NODE_CONTINUOUS ) {
  
    // determine if range of values or simple comparison
    // print question: operator + value  *or*  min + operator + max
    //
    if (min_d == max_d) {
      sprintf((char*)question_d, "%s%s%f", (char*)label_d, (char*)oper_a,
	      min_d);
    }
    else {
      sprintf((char*)question_d, "%f%s%s%s%f",  min_d,
	      (char*)oper_a, (char*)label_d, (char*)oper_a, max_d);
    }
  }

  if ( split_type_d == TREE_NODE_DISCRETE ) {

    char_1* temp_str = new char_1[ISIP_MAX_STRING_LENGTH];

    // concatenate all discrete values
    // print question: operator + value1, value2, ...., valuen
    //
    for ( int_4 i=0; i<num_discrete_values_d; i++ ) {
      strcat((char*)temp_str,(char*)discrete_values_d[i]);
      if ( i != num_discrete_values_d-1 )
	strcat((char*)temp_str,(char*)", ");
    }
    sprintf((char*)question_d, "%s%s%s",  (char*)label_d, (char*)oper_a,
	    (char*)temp_str);
    delete [] temp_str;
  }
    
  // return question at the tree node
  //
  return question_d;
}
