// file: $DT/class/tree_node/v1.0/tn_get_5.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: get_contents_cc
//
// arguments: none
//
// return: string containing formatted data from the node
//
// this method returns the question asked at the node in string form that
// is formatted and tagged with the level it is on
//
char_1* Tree_node::get_contents_cc(int_4 display_level_a) {

  // make sure output does not already exist
  //
  if ( output_d != (char_1*)NULL )
    delete [] output_d;

  // allocate memory
  //
  output_d = new char_1[ISIP_MAX_STRING_LENGTH];
  
  // print tag showing level 
  //
  sprintf((char*)output_d, "<L%ld> ", level_d);
  
  // format the output
  //
  for ( int_4 i=0; i<level_d; i++ ) {
    strcat((char*)output_d, (char*)TREE_NODE_WHITE_SPACE);
  }
  
  strcat((char*)output_d, (char*)get_question_cc());

  // get count or probability at the node if specified
  //
  if ( display_level_a != DT_DISPLAY_BASIC ) {

    char_1* output_a = new char_1[ISIP_MAX_STRING_LENGTH];

    if ( display_level_a == DT_DISPLAY_COUNT ) {

      if ( count_d == (int_4*)NULL )
	error_handler_cc( (char_1*)"get_contents_cc",
			  (char_1*)"tried to output count when none exists");

      // copy contents of count array into a string
      //
      char_1* count_str = new char_1[ISIP_MAX_STRING_LENGTH];
      print_counts_cc( count_str );
      sprintf( (char*)output_a, "%s %s%s", output_d, " c: ", count_str );
      delete [] count_str;
    }

    else {

      if ( probability_d == (float_4*)NULL )
	error_handler_cc( (char_1*)"get_contents_cc",
			  (char_1*)"tried to output prob when none exists");

      // copy contents of prob array into a string
      //
      char_1* prob_str = new char_1[ISIP_MAX_STRING_LENGTH];
      print_probs_cc( prob_str );
      sprintf((char*)output_a, "%s %s%s", output_d, " p: ", prob_str);
      delete [] prob_str;
    }
    
    strcpy((char*)output_d, (char*)output_a);
    delete [] output_a;
  }

  // if the node is terminal, determine its class
  //
  if ( is_terminal_cc() ) {
    char_1* classify = assign_class_cc();
    strcat((char*)output_d, (char*)"  ");
    strcat((char*)output_d, (char*)classify);
  }
  
  // return question at the tree node
  //
  return output_d;
}
