// file: $DT/class/tree_node/v1.0/tn_get_8.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: get_detailed_cc
//
// arguments: none
//
// return: string containing formatted data from the node
//
// this method returns the question asked at the node in string form that
// is formatted and tagged with the level it is on.  this is for use only
// with the output tree file intended for readin in of the tree.
//
char_1* Tree_node::get_detailed_cc() {

  char_1* output_a = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* output2_a = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* output3_a = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* count_str = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* prob_str = new char_1[ISIP_MAX_STRING_LENGTH];

  // if output_d exists, delete it and allocate more space
  //
  if ( output_d != (char_1*)NULL )
    delete [] output_d;

  output_d = new char_1[ISIP_MAX_STRING_LENGTH];

  // take out comments
  //
  // print tag showing level and if binary or trinary question
  //
  //if ( max_d == min_d ) {
    sprintf((char*)output_a, "<B%ld> ", level_d);
    // }
  //  else {
  //  sprintf((char*)output_a, "<T%ld> ", level_d);
  //}

  // print the question at the node
  //
  strcat((char*)output_a, (char*)get_question_cc());

  // get count at the node
  //
  if ( count_d == (int_4*)NULL ) {
    // output tag that no count
    //
    sprintf( (char*)count_str, "%s", (char*)TREE_NODE_NO_COUNT );
  }
  else {
    print_counts_cc(count_str);
  }
  sprintf( (char*)output2_a, "\n%s%s\n", "c: ", count_str );

  // get probability at the node
  //
  if ( probability_d == (float_4*)NULL ) {
    // output tag that no probs
    //
    sprintf( (char*)prob_str, "%s", (char*)TREE_NODE_NO_PROBS );
  }
  else {
    print_probs_cc(prob_str);
  }
  sprintf((char*)output3_a, "%s%s", "p: ", prob_str);

  sprintf((char*)output_d,"%s%s%s",output_a,output2_a,output3_a);

  delete [] output_a;
  delete [] output2_a;
  delete [] output3_a;
  delete [] count_str;
  delete [] prob_str;
  
  // return question at the tree node
  //
  return output_d;
}
