// file: $DT/class/tree_node/v1.0/tn_node_3.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include <integral_constants.h>

// method: ask_question_cc
//
// arguments: float_4 test_a is the value in question
//
// return: logical_1 flag to indicate success/failure of operator
//
// this method determines whether the test value is within a specified range
//
logical_1 Tree_node::ask_question_cc(float_4 test_a) {

  // answer to question is either true or false; default is false.
  //
  logical_1 answer_a = ISIP_FALSE;

  // if min and max are equal then one sided question
  //
  if ( (min_d==max_d) ) {

    // determine operator specified and perform operation
    //
    switch (operator_d) {
    case TREE_NODE_GT:
      if (test_a > min_d) {
	answer_a = ISIP_TRUE;
      }
      break;
    case TREE_NODE_LT:
      if (test_a < min_d) {
	answer_a = ISIP_TRUE;
      }
      break;
    case TREE_NODE_GTE:
      if (test_a >= min_d) {
	answer_a = ISIP_TRUE;
      }
      break;
    case TREE_NODE_LTE:
      if (test_a <= min_d) {
	answer_a = ISIP_TRUE;
      }
      break;
    case TREE_NODE_EQ:
      if (test_a == min_d) {
	answer_a = ISIP_TRUE;
      }
      break;
    }
  }
  // min and max are not equal, therefore a range is specified
  //
  else {
    // check to see if range is [min,max]
    //
    if ( operator_d == TREE_NODE_RANGE_INCLUSIVE ) {
      if ((test_a >= min_d) && (test_a <= max_d)) {
	answer_a = ISIP_TRUE;
      }
    }
    // if range is not [min,max], then assumed that range is (min,max)
    else {
      if ((test_a >= min_d) && (test_a <= max_d)) {
	answer_a = ISIP_TRUE;
      }
    }
  }

  // return answer to the question
  //
  return answer_a;
}
