// file: $DT/class/tree_node/v1.0/tn_node_4.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include <integral_constants.h>

// method: ask_question_cc
//
// arguments: char_1* test_a is the value in question
//
// return: logical_1 flag to indicate success/failure of operator
//
// this method determines whether the test value is a member of the
// discrete values contained at the node
//
logical_1 Tree_node::ask_question_cc(char_1* test_a) {

  // answer to question is either true or false; default is false.
  //
  logical_1 answer_a = ISIP_FALSE;

  // check each discrete value to see if test case is in one of these
  // discrete values
  //
  for ( int_4 i=0; i<num_discrete_values_d; i++ ) {

    if ( strcmp((char*)test_a,(char*)discrete_values_d[i]) == 0 ) {
      answer_a = ISIP_TRUE;
      break;
    }
  }

  // return answer to the question
  //
  return answer_a;
}
