// file: $DT/class/tree_node/v1.0/tn_set_0.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include <integral_constants.h>

// method: set_node_cc
//
// arguments: float_4 min_a    minimum number in range
//            float_4 max_a    maximum number in range
//            int_4 operator_d operator used for question
//            char_1* attr_label_a  attribute label
//
// return: logical_1 flag to indicate success
//
// this method sets the data required for a question
//
logical_1 Tree_node::set_node_cc(float_4 min_a, float_4 max_a,
				 int_4 operator_a, char_1* attr_label_a) {

  // set protected data equal to data passed in
  //
  min_d = min_a;
  max_d = max_a;
  operator_d = operator_a;
  if (label_d != (char_1*)NULL) {
    delete [] label_d;
  }
  label_d = new char_1[ISIP_MAX_STRING_LENGTH];
  strcpy((char*)label_d, (char*)attr_label_a);
  split_type_d = TREE_NODE_CONTINUOUS;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
