// file: $DT/class/tree_node/v1.0/tn_set_3.cc
//

// isip include files
//
#include "tree_node.h"
#include <integral_constants.h>
 
// method: set_probability_cc
//
// arguments: float_4 probability_a
//
// return: logical_1 indicating success
//
// this method sets the prob of the node
//
logical_1 Tree_node::set_probability_cc(float_4* probability_a, int_4 size_a) {

  // check if number of classes is initialized, set if not
  //
  if ( num_class_d == 0 ){
    num_class_d = size_a;
  }

  // if number of classes do not match then error
  //
  else {
    if ( num_class_d != size_a ) {
      error_handler_cc( (char_1*)"set_probability_cc",
			(char_1*)"incorrect number of classes");
    }
  }

  // if count array exists, delete it
  //
  if ( probability_d != (float_4*)NULL )
    delete [] probability_d;

  probability_d = new float_4[size_a];

  // copy array into the count array
  //
  for ( int_4 i=0; i<num_class_d; i++ )
    probability_d[i] = probability_a[i];
  
  // exit gracefully
  //
  return ISIP_TRUE;

}
