// file: $DT/class/tree_node/v1.0/tn_set_6.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: set_node_cc
//
// arguments: int_4* mask_a... mask for the split
//            char_1** discrete_values_a... possibles split values
//            int_4 DT_SPLIT_LEFT or DT_SPLIT_RIGHT
//            int_4 operator_d operator used for question
//            char_1* attr_label_a  attribute label
//
// return: logical_1 flag to indicate success
//
// this method sets the data required for a question
//
logical_1 Tree_node::set_node_cc(int_4* mask_a, Attribute_node* node_a,
				 int_4 split_a, int_4 operator_a,
				 char_1* attr_label_a) {

  int_4 left_a=0;
  int_4 right_a=0;
  int_4 temp_num;
  int_4 index=0;
  int_4 num_values_a;
  char_1** values_a;

  // set protected data equal to data passed in
  //
  operator_d = operator_a;
  if ( label_d != (char_1*)NULL )
    delete [] label_d;
  label_d = new char_1[ISIP_MAX_STRING_LENGTH];
  strcpy((char*)label_d, (char*)attr_label_a);
  split_type_d = TREE_NODE_DISCRETE;

  node_a->get_num_values_cc(num_values_a);
  values_a=new char_1*[num_values_a];
  for ( int_4 i=0; i<num_values_a; i++ ) {
    values_a[i]=new char_1[ISIP_MAX_STRING_LENGTH];
  }
  node_a->get_values_cc(values_a);
  
  // count number of discrete values for this split
  //
  for ( int_4 i=0; i<num_values_a; i++ ) {
    if ( mask_a[i] == DT_SPLIT_LEFT ) 
      left_a++;
    else
      right_a++;
  }

  if ( split_a == DT_SPLIT_LEFT )
    temp_num = left_a;
  else
    temp_num = right_a;

  // allocate space for the discrete values
  //
  for (int_4 i=0; i<num_discrete_values_d; i++) {
    if (discrete_values_d[i] != (char_1*)NULL) {
      delete [] discrete_values_d[i];
    }
  }
  if (discrete_values_d != (char_1**)NULL) {
    delete [] discrete_values_d;
  }

  num_discrete_values_d = temp_num;
  
  discrete_values_d = new char_1*[temp_num];
  for ( int_4 i=0; i<temp_num; i++ )
    discrete_values_d[i]=new char_1[ISIP_MAX_STRING_LENGTH];

  // copy the discrete values into the node
  //
  for ( int_4 i=0; i<num_values_a; i++ ) {
    if ( split_a == DT_SPLIT_LEFT ) {
      if ( mask_a[i] == DT_SPLIT_LEFT ){
	strcpy((char*)discrete_values_d[index],(char*)values_a[i]);
	index++;
      }
    }
    else {
      if ( mask_a[i] == DT_SPLIT_RIGHT ){
	strcpy((char*)discrete_values_d[index],(char*)values_a[i]);
	index++;
      }
    }
  }

  for ( int_4 i=0; i<num_values_a; i++ ) {
    delete [] values_a[i];
  }
  delete [] values_a;
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
