// file: $DT/class/tree_node/v1.0/tn_set_7.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: set_node_cc
//
// arguments: int_4* mask_a... mask for the split
//            char_1** discrete_values_a... possibles split values
//            int_4 DT_SPLIT_LEFT or DT_SPLIT_RIGHT
//            int_4 operator_d operator used for question
//            char_1* attr_label_a  attribute label
//
// return: logical_1 flag to indicate success
//
// this method sets the data required for a question
//
logical_1 Tree_node::set_node_cc( char_1** discrete_values_a, int_4 num_a,
				  char_1* attr_label_a ) {

  operator_d = TREE_NODE_EQ;
  if ( label_d != (char_1*)NULL )
    delete [] label_d;
  label_d = new char_1[ISIP_MAX_STRING_LENGTH];
  strcpy((char*)label_d, (char*)attr_label_a);
  split_type_d = TREE_NODE_DISCRETE;

  // allocate space for the discrete values
  //
  for (int_4 i=0; i<num_discrete_values_d; i++) {
    if (discrete_values_d[i] != (char_1*)NULL) {
      delete [] discrete_values_d[i];
    }
  }
  if (discrete_values_d != (char_1**)NULL) {
    delete [] discrete_values_d;
  }
  
  num_discrete_values_d=num_a;
  discrete_values_d = new char_1*[num_a];

  for ( int_4 i=0; i<num_discrete_values_d; i++ )
    discrete_values_d[i]=new char_1[ISIP_MAX_STRING_LENGTH];

  // copy the discrete values into the node
  //
  for ( int_4 i=0; i<num_discrete_values_d; i++ ) {
    strcpy((char*)discrete_values_d[i],(char*)discrete_values_a[i]);
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
