// file: $DT/class/v1.0/tree_node/tree_node_constants.h
//
 
// make sure the definitions are made only once
//
#ifndef __ISIP_TREE_NODE_CONSTANTS
#define __ISIP_TREE_NODE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the class name
//
#define TREE_NODE_CLASS_NAME (char_1*)"Tree_node"

// define available operators for questions at the node
//
#define TREE_NODE_GT (int_4)0
#define TREE_NODE_LT (int_4)1
#define TREE_NODE_GTE (int_4)2	
#define TREE_NODE_LTE (int_4)3
#define TREE_NODE_EQ (int_4)4
#define TREE_NODE_RANGE_INCLUSIVE (int_4)5
#define TREE_NODE_RANGE_EXCLUSIVE (int_4)6

// define string constants for each operator
//
#define TREE_NODE_GT_STR (char_1*)" > "
#define TREE_NODE_LT_STR (char_1*)" < "
#define TREE_NODE_GTE_STR (char_1*)" >= "
#define TREE_NODE_LTE_STR (char_1*)" <= "
#define TREE_NODE_EQ_STR (char_1*)" = "
#define TREE_NODE_RANGE_INCLUSIVE_STR (char_1*)" <= ? <= "
#define TREE_NODE_RANGE_EXCLUSIVE_STR (char_1*)" < ? < "

// define formatting white space for output of node parameters
//
#define TREE_NODE_WHITE_SPACE (char_1*)"|   "

// define strings for outputting details of counts and probabilities
//
#define TREE_NODE_NO_COUNT (char_1*)"no count"
#define TREE_NODE_NO_PROBS (char_1*)"no probs"

// define constants for discrete and continuous flags
//
#define TREE_NODE_DISCRETE (int_4)0
#define TREE_NODE_CONTINUOUS (int_4)1

// end of file
//
#endif

