#!/bin/sh

# file: make_pron.sh
#
# this function recursively builds the Pronmann machine n-best
# pronunciation generation software. it provides a simpler
# way to do this than imake.
#
# its arguments are:
#
#    make_pron.sh make_options...
#
# for example,
#
#    make_pron.sh -j3
#
# will make and install all isip classes.
#

# define tools
#
ISIP_MTOOL="$ISIP_PRON_DEMO/bin/make_all.sh"

# load the libraries
#
$ISIP_MTOOL $ISIP_PRON_DEMO/src/class/ install $*;

# load the executable
#
$ISIP_MTOOL $ISIP_PRON_DEMO/src/util/generate_pron/ install $*;

# exit gracefully
# 
exit 0;
