# File : audio_cfg_proc.tcl
#
proc audio_cfg_proc {} {
    global audio_device
    global audio_command
    global audio_sf
    global audio_play_speed
    global au_device au_command au_sf au_speed
    global w_au_cfg

    set w_au_cfg ".audio_cfg"

    # don't recreate the window, try to reuse existing one
    #
    if { [winfo exists $w_au_cfg] == 1 } {
        wm deiconify $w_au_cfg
        raise $w_au_cfg
 
    } else {
 
	set au_sf $audio_sf
	set au_command $audio_command
	set au_device $audio_device
	set au_speed $audio_play_speed

        # create a new window
        #
        toplevel $w_au_cfg
	frame $w_au_cfg.foot
        wm title $w_au_cfg "Audio Configuration"
        button $w_au_cfg.ok -text Ok -command audio_ok_proc

	pack $w_au_cfg.foot -side bottom -fill x -pady 2m

	button $w_au_cfg.cancel -text Cancel -command "destroy $w_au_cfg"
        pack $w_au_cfg.ok -side left -in $w_au_cfg.foot -fill x -padx 20m
        pack $w_au_cfg.cancel -side right -in $w_au_cfg.foot -fill x -padx 20m

	frame $w_au_cfg.sf_frame
	frame $w_au_cfg.speed_frame
	frame $w_au_cfg.command_frame
	frame $w_au_cfg.device_frame

	set entry_width 70
	pack $w_au_cfg.sf_frame $w_au_cfg.speed_frame $w_au_cfg.command_frame \
		$w_au_cfg.device_frame -side top
	
	# setup the sample frequency stuff
	#
	label $w_au_cfg.sf_label -text "Sample Frequency" -width 20 -anchor w
	entry $w_au_cfg.sf_entry -textvariable au_sf -width $entry_width
	bind $w_au_cfg.sf_entry <Return> audio_ok_proc

	pack $w_au_cfg.sf_entry -side right -in $w_au_cfg.sf_frame
	pack $w_au_cfg.sf_label -side left -in $w_au_cfg.sf_frame\
		-fill x -expand true

	# setup the play speed stuff
	#
	label $w_au_cfg.speed_label -text "Play Speed" -width 20 -anchor w
	entry $w_au_cfg.speed_entry -textvariable au_speed -width $entry_width
	bind $w_au_cfg.speed_entry <Return> audio_ok_proc

	pack $w_au_cfg.speed_entry -side right -in $w_au_cfg.speed_frame
	pack $w_au_cfg.speed_label -side left -in $w_au_cfg.speed_frame \
		-fill x -expand true

	# setup the play command stuff
	#
	label $w_au_cfg.command_label -text "Play Command" -width 20 -anchor w
	entry $w_au_cfg.command_entry -textvariable au_command \
		-width $entry_width
	bind $w_au_cfg.command_entry <Return> audio_ok_proc
	pack $w_au_cfg.command_entry -side right -in $w_au_cfg.command_frame
	pack $w_au_cfg.command_label -side left -in $w_au_cfg.command_frame \
		-fill x \
		-expand true

	# setup the play device stuff
	#
	label $w_au_cfg.device_label -text "Play Device" -width 20 -anchor w
	entry $w_au_cfg.device_entry -textvariable au_device \
		-width $entry_width
	bind $w_au_cfg.device_entry <Return> audio_ok_proc

	pack $w_au_cfg.device_entry -side right -in $w_au_cfg.device_frame
	pack $w_au_cfg.device_label -side left -in $w_au_cfg.device_frame -fill x \
		-expand true		
    }
}

proc audio_ok_proc {} {
    global audio_device
    global audio_command
    global audio_sf
    global audio_play_speed
    global au_device au_command au_sf au_speed
    global w_au_cfg

    set audio_device $au_device
    set audio_command $au_command
    set audio_sf $au_sf
    set audio_play_speed $au_speed
    destroy $w_au_cfg
}
