# File : globals.tcl
#

# This file declares the globals for the GUI for the N-best pronunciations
# Boltzmann network program
#

# declare globals
#
global p
global pron_title
global pron_bmp
global pron_context
global pron_alg
global params_dir
global pron_params
global name_spell
global in_data
global in_file
global out_file
global net_file
global tmp1_file
global tmp2_file
global num_n_best
global max_n_best
global min_n_best
global build_net
global generate_pron
global generate_tree
global rebuild
global name_to_context
global namepron_to_context
global contextpron_to_name
global volume
global audio_device
global audio_command
global audio_sf
global audio_play_speed
global phones_list
global fore_color back_color
global tts_prog tts_opts 
global audio_tmp_file audio_map_file

# define globals
#
set p ".p"
set pron_title "N-best Pronunciations for Proper Nouns"
set pron_bmp "$env(ISIP_PRON_DEMO)/bitmaps"

# globals for pronunciation generation
#
set pron_context "5"
set pron_alg "bayes"
set params_dir "$env(ISIP_PRON_DEMO)/params"
set pron_params "$params_dir/decision_tree/context_5_bayes.tree"
set name_spell ""
set in_data "/tmp/names_[pid].data"
set in_file "/tmp/names_[pid].file"
set out_file "/tmp/pronounce_[pid].out"
set net_file "/tmp/phone_net_[pid].out"
set tmp1_file "/tmp/tmp1_[pid].out"
set tmp2_file "/tmp/tmp2_[pid].out"
set num_n_best 5
set max_n_best 11
set min_n_best 1
set build_net "$env(ISIP_PRON_DEMO)/bin/$env(ISIP_BINARY)/build_net"
set generate_pron "$env(ISIP_PRON_DEMO)/bin/$env(ISIP_BINARY)/generate_pron"
set analyze_dtree "$env(ISIP_PRON_DEMO)/bin/$env(ISIP_BINARY)/analyze_dtree"
set name_to_context "$env(ISIP_PRON_DEMO)/bin/name_to_context.pl"
set contextpron_to_name "$env(ISIP_PRON_DEMO)/bin/contextpron_to_name.pl"
set rebuild "$env(ISIP_PRON_DEMO)/bin/$env(ISIP_BINARY)/rebuild"

# globals for audio
#
set volume 1.5
set audio_device ""
set audio_command $env(ISIP_PRON_DEMO)/bin/isip_play
set audio_sf 8000
set audio_play_speed 1
set phones_list {}
set audio_map_file "$env(ISIP_PRON_DEMO)/src/include/arpabet_to_worldbet.map"
set audio_tmp_file "/tmp/pron_[pid].au"
set tts_prog "$env(ISIP_PRON_DEMO)/bin/$env(ISIP_BINARY)/text_to_speech"

# set colors
#
set fore_color Black
set back_color White

# end of file
#
