#! /usr/local/gnu/bin/bash

ISIP_PRON_DEMO="$PWD";
export ISIP_PRON_DEMO;
echo "Set demo directory path as" $ISIP_PRON_DEMO

echo "Installing the Boltzmann Machine..."
echo "Please stand by!"
echo "   "
$ISIP_PRON_DEMO/bin/make_pron.sh -j8
rm -f $ISIP_PRON_DEMO/src/class/*/*.o
rm -f $ISIP_PRON_DEMO/src/util/generate_pron/*.o 
rm -f $ISIP_PRON_DEMO/src/util/generate_pron/*.exe
echo "   "
echo "Installation of Boltzmann machine complete."
echo "   "

echo "Installing decision trees software..."
echo "Please stand by!"
echo "   "
pushd $ISIP_PRON_DEMO/src/util/generate_tree
make install -j8
rm -f *.o
popd
pushd $ISIP_PRON_DEMO/src/util/rebuild
make install -j8
rm -f *.o
popd
echo "Installation of decision trees complete."
echo "   "

echo "Installing text-to-speech software..."
echo "Please stand by!"
echo "   "
pushd $ISIP_PRON_DEMO/src/util/text_to_speech/
Make.sh
popd
echo "Installation of text-to-speech software complete."
echo "   "

echo "Installing rsynth v2.0..."
echo "Please stand by!"
echo "   "
pushd $ISIP_PRON_DEMO/src/util/rsynth/
make -j8
echo ar r $ISIP_PRON_DEMO/lib/$ISIP_BINARY/lib_rsynth.a *.o
ar r $ISIP_PRON_DEMO/lib/$ISIP_BINARY/lib_rsynth.a *.o
rm -f *.o
popd
echo "Installation of rsynth complete."
echo "   "

echo "Installing the GUI software..."
echo "Please stand by!"
echo "   "
$ISIP_PRON_DEMO/bin/make_buildnet.sh -j8
rm -f $ISIP_PRON_DEMO/src/util/build_net/*.o
rm -f $ISIP_PRON_DEMO/src/util/build_net/*.exe

echo "export ISIP_PRON_DEMO"=$ISIP_PRON_DEMO > $ISIP_PRON_DEMO/pronunciations_demo.sh
echo "$ISIP_PRON_DEMO/gui/main.tcl &" >> $ISIP_PRON_DEMO/pronunciations_demo.sh
chmod ugo+x $ISIP_PRON_DEMO/gui/main.tcl
chmod ugo+x $ISIP_PRON_DEMO/pronunciations_demo.sh
echo "Installation of GUI software complete."
echo "   "

echo "The installation is complete now. You are welcome to run the demo."
echo "Please begin by typing the following command:"
echo "    "
echo ". pronunciations_demo.sh"
