// file bm_comp_1.cc
//
// method to compute the net output error of the boltzmann machine 
// for one input letter
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: total_error_cc
//
// arguments: none
//
// return: a logical_1 to indicate success
//
// this method computes the mean squared error during training for
// one input letter and appends it to the net error
// 
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: total_error_cc () {

  // dummy variables
  //
  int_4 i = 0;
  float_4 sq_error_l = 0;
  
  // compute the squared output error
  //
  for (i = 0; i < num_output_neurons_d; i++) {
    sq_error_l += pow (error_out_d[i], 2.0);
  }
  
  // increment the average mean squared error
  //
  error_d += (sq_error_l / num_output_neurons_d);

  // exit gracefully
  //
  return (ISIP_TRUE);
}
