// file bm_cstr_0.cc
//
// destructor
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: destructor
//
// arguments: none
//
// return: none
//
// this is the destructor for the boltzman machine class
//-----------------------------------------------------------------------------

Boltz_machine :: ~Boltz_machine () {

  // cleanup memory in character strings
  //
  delete [] context_type_d;
  delete [] seed_type_d;
  
  // free memory in matrices and vectors
  //
  delete [] wt_in_hid_short_d;
  delete [] wt_hid_out_short_d;
  delete [] wt_in_hid_long_d;
  delete [] wt_hid_out_long_d;
  delete [] up_in_hid_short_d;
  delete [] up_hid_out_short_d;
  delete [] up_in_hid_long_d;
  delete [] up_hid_out_long_d;

  delete [] error_hid_short_d;
  delete [] error_hid_long_d;
  delete error_out_d;

  delete num_hidden_short_d;
  delete num_hidden_long_d;
  
  // free memory in member objects
  //
  delete input_short_d;
  delete input_long_d;
  delete [] hidden_short_d;
  delete [] hidden_long_d;
  delete [] output_neuron_d;
  
  // exit gracefully
  //
}
