// file bm_file_0.cc
//
// method to open a file and verify existence
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: open_file_cc
//
// arguments:
//     char_1* name_a: (input) name of the file
//     char_1* mode_a: (input) open mode of file
//
// return: a FILE* pointer to file opened
//
// this method verifies and opens a file in the appropriate mode
//
//-----------------------------------------------------------------------------

FILE* Boltz_machine :: open_file_cc (char_1* name_a, char_1* mode_a) {
  
  // create file pointer
  //
  FILE *file_l = fopen ((char*)name_a, (char*)mode_a);

  // verify that it exists
  //
  if (file_l == NULL) {
    fprintf (stderr, "Cannot open file %s \n", name_a);
    exit (ISIP_ERROR);
  }

  // exit gracefully by returning file pointer
  //
  return (file_l);
}
