// file bm_file_4.cc
//
// method to write the connecting weights for one layer from file
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: print_weights_cc
//
// arguments:
//     int_4 rows_a: (input) number of rows of matrix
//     int_4 cols_a: (input) number of columns of matrix
//     float_4** weight_a: (input) the matrix to be loaded
//     char_1* file_a: (input) name of the file containing model filename
//
// return: a logical_1 to indicate success
//
// this method writes the connecting weights for a particular layer along
// with its dimensions
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: print_weights_cc (int_4 rows_a, int_4 cols_a, 
					     float_4** weight_a, 
					     char_1* file_a) {

  // dummy index variables
  //
  int_4 i = 0;
  int_4 j = 0;
  
  // open the output file
  //
  FILE* wt_file_l = open_file_cc (file_a, (char_1*)"w");
  
  // write the matrix size
  //
  fprintf (wt_file_l, "%ld %ld\n\n", rows_a, cols_a);

  // write the matrix values
  //
  for (i = 0; i < rows_a; i++) {
    for (j = 0; j < cols_a; j++) {
      fprintf (wt_file_l, "%.4f ", weight_a[i][j]);
    }
    fprintf (wt_file_l, "\n");
  }
  
  // free strings and close files
  //
  fclose (wt_file_l);
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
