// file bm_get_0.cc
//
// method to output the phoneme generated for a particular input letter
//

// isip include files
//
#include "boltz_machine.h"
#include <boltz_characters.h>

//-----------------------------------------------------------------------------
// method: get_phoneme_cc
//
// arguments:
//      char_1* pron_a: (output) the output phoneme
//
// return: a logical_1 to indicate success
//
// this method reads the output bits of the network and accordingly
// computes the corresponding phoneme
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: get_phoneme_cc (char_1* pron_a) {
  
  // dummy variable
  //
  int_4 index_l = 0;
  float_4 bit_l = 0;
  
  // convert binary to decimal
  //
  for (int_4 i = 0; i < num_output_neurons_d; i++)  {
    output_neuron_d[i].output_cc (bit_l);
    if (bit_l > 0.5) {
      index_l = index_l | two_power_d[i];
    }
  }
  
  // find corresponding phoneme string
  //
  if (index_l < NUM_PHONEMES) {
    strcpy ((char*)pron_a, (char*)output_phoneme_d[index_l]);
  }
  else {
    strcpy ((char*)pron_a, "_");
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}
