// file bm_get_1.cc
//
// method to output the log-likelihood score for a pronunciation
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: get_likelihood_cc
//
// arguments:
//      float_4 &lhood_a: (output) the likelihood of the output pronunciation
//
// return: a logical_1 to indicate success
//
// this method reads the output probabilities of the network and accordingly
// computes the corresponding log-likelihood of the pronunciation
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: get_likelihood_cc (float_4 &lhood_a) {
  
  // dummy variables
  //
  float_4 prob_l = 1.0;
  int_4 i = 0;
  
  // initialize the likelihood score
  //
  lhood_a = 0;
  
  for (i = 0; i < num_output_neurons_d; i++) {

    // read the output probability of neurons
    //
    output_neuron_d[i].likelihood_cc (prob_l);
    
    // compute log-likelihood score
    //
    if (prob_l > 0) {
      lhood_a += log (prob_l);
    }
  }
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
