// file bm_load_0.cc
//
// method to load the name spelling in the appropriate input buffer
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: load_spell_cc
//
// arguments:
//     char_1* name_a: (input) the input name to be loaded in buffer
//
// return: a logical_1 to indicate success
//
// this method loads the input name spelling in the appropriate input buffer
// by checking the context used
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: load_spell_cc (char_1* name_a) {
  
  // check context and load appropriate input buffer
  //
  if ((context_d == BOLTZ_SHORT) || (context_d == BOLTZ_BOTH)) {
    input_short_d->load_cc (name_a);
  }
  if ((context_d == BOLTZ_LONG) || (context_d == BOLTZ_BOTH)) {
    input_long_d->load_cc (name_a);
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}
