// file bm_load_2.cc
//
// method to shift letters of the name spelling in the appropriate input buffer
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: shift_word_cc
//
// arguments: none
//
// return: a logical_1 to indicate success
//
// this method shifts the input name spelling in the appropriate input buffer
// by checking the context used
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: shift_word_cc () {
  
  // check context and shift name in the appropriate input buffer
  //
  if ((context_d == BOLTZ_SHORT) || (context_d == BOLTZ_BOTH)) {
    input_short_d->shift_cc ();
  }
  if ((context_d == BOLTZ_LONG) || (context_d == BOLTZ_BOTH)) {
    input_long_d->shift_cc ();
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}
