// file bm_load_3.cc
//
// method to check if the input buffers are empty
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: input_empty_cc
//
// arguments: none
//
// return: a logical_1 to indicate success
//
// this method checks whether the appropriate input buffer is empty
//
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: input_empty_cc () {

  // dummy variable
  //
  logical_1 status_l = ISIP_FALSE;
  
  // check context and shift name in the appropriate input buffer
  //
  if ((context_d == BOLTZ_SHORT) || (context_d == BOLTZ_BOTH)) {
    status_l = input_short_d->empty_cc ();
  }
  if ((context_d == BOLTZ_LONG) || (context_d == BOLTZ_BOTH)) {
    status_l = input_long_d->empty_cc ();
  }

  // exit gracefully by returning the buffer status
  //
  return (status_l);
}
