// file bm_update_0.cc
//
// method to update the system training momentum term
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: up_momentum_cc
//
// arguments: none
//
// return: a logical_1 to indicate success
//
// this method updates the momentum term used in updating the weights
// 
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: up_momentum_cc () {

  // dummy variables
  //
  static float_4 moment_l = DEFAULT_FINAL_MOMENTUM;
  
  // scale the momentum value
  //
  moment_l *= exponent_d;
  momentum_d = final_momentum_d - moment_l;
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
