// file bm_update_1.cc
//
// method to update the system temperature term
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: up_temperature_cc
//
// arguments:  none
//
// return: a logical_1 to indicate success
//
// this method updates the system temperature term
// 
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: up_temperature_cc () {

  // dummy variable
  //
  static float_4 in_temp_l = init_temp_d;
  
  // scale the temperature value
  //
  temperature_d = in_temp_l;
  in_temp_l *= exponent_d;

  // pass on this value to all the neurons
  //
  Boltz_neuron :: set_inv_temp_cc (1.0 / temperature_d);

  // exit gracefully
  //
  return (ISIP_TRUE);
}
