// file bm_update_2.cc
//
// method to update the connection weights between neuron layers
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: up_weights_cc
//
// arguments: none
//
// return: a logical_1 to indicate success
//
// this method updates the weight matrices according to context
// 
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: up_weights_cc () {

  // index variable
  //
  int_4 k = 0;
  
  // for short context
  //
  if ((context_d == BOLTZ_SHORT) || (context_d == BOLTZ_BOTH)) {
    add_matrix_cc (wt_in_hid_short_d, up_in_hid_short_d,
		   num_short_inputs_d + 1, num_hidden_short_d[0]);

    for (k = 0; k < num_layers_short_d; k++) {
      add_matrix_cc (wt_hid_out_short_d[k], up_hid_out_short_d[k],
		     num_hidden_short_d[k] + 1, num_hidden_short_d[k+1]);
    }
  }

  // for long context
  //
  if ((context_d == BOLTZ_LONG) || (context_d == BOLTZ_BOTH)) {
    add_matrix_cc (wt_in_hid_long_d, up_in_hid_long_d,
		   num_long_inputs_d + 1, num_hidden_long_d[0]);

    for (k = 0; k < num_layers_long_d; k++) {
      add_matrix_cc (wt_hid_out_long_d[k], up_hid_out_long_d[k],
		     num_hidden_long_d[k] + 1, num_hidden_long_d[k+1]);
    }
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}
