// file bm_update_3.cc
//
// method to add two matrices
//

// isip include files
//
#include "boltz_machine.h"

//-----------------------------------------------------------------------------
// method: add_matrix_cc
//
// arguments:
//     float_4** mat1_a: (input) the matrix to be updated
//     float_4** mat2_a: (input) the matrix to be added
//     int_4 rows_a: (input) number of rows
//     int_4 cols_a: (input) number of columns
//
// return: a logical_1 to indicate success
//
// this method adds the contents of matrix 2 into matrix 1
// 
//-----------------------------------------------------------------------------

logical_1 Boltz_machine :: add_matrix_cc (float_4** mat1_a, float_4** mat2_a, 
					  int_4 rows_a, int_4 cols_a) {

  // add the matrices term by term
  //
  for (int_4 i = 0; i < rows_a; i++) {
    for (int_4 j = 0; j < cols_a; j++) {
      mat1_a[i][j] += mat2_a[i][j];
    }
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}
