// file: ib_cstr_1.cc
//
// constructor
//

// isip include files
//
#include "input_buffer.h"
#include <boltz_characters.h>

//-----------------------------------------------------------------------------
// method: constructor
//
// arguments:
//     int_4 size_a: (input) number of characters stored in the buffer
//
// return: none
//
// this is the default constructor for the input buffer class 
// of a boltzman machine
//
//-----------------------------------------------------------------------------

Input_buffer :: Input_buffer (int_4 size_a) {

  // initialize size variables
  //
  in_size_d = size_a;
  num_input_bits_d = BITS_PER_IN_CHAR;
  out_size_d = in_size_d * num_input_bits_d;
  index_d = 0;
  name_length_d = 0;

  // allocate memory for input and output
  //
  input_d = new char_1[in_size_d];
  output_d = new float_4[out_size_d];

  // allocate memory for the name string
  //
  name_d = new char_1[MAX_WORD_SIZE];
  
  // exit gracefully
  //
}
