// file: ib_load_0.cc
//
// method to load a name in the buffer
//

// isip include files
//
#include "input_buffer.h"

//-----------------------------------------------------------------------------
// method: load_cc
//
// arguments:
//     char_1* name_a: (input) name to load in the buffer
//
// return: a logical_1 value indicating success
//
// this method loads the input name in the buffer
// only the first specified number of letters are loaded, the first being
// in the center of the buffer
//
//-----------------------------------------------------------------------------

logical_1 Input_buffer :: load_cc (char_1* name_a) {

  // dummy index variable
  //
  int_4 i = 0;
  
  // copy the new name to be stored
  //
  strcpy ((char*)name_d, (char*)name_a);
  name_length_d = strlen ((char*)name_d);

  // clear previous contents of the buffer
  //
  clear_cc ();

  // reset the index
  //
  index_d = in_size_d/2;
  
  // read the characters of the word one by one and
  // shift them to the right till they reach center of the buffer
  //
  for (i = 0; i < index_d + 1; i++) {

    // set the appropriate letters
    //
    input_d[index_d - i] = name_d[i];
    
    // set the output corresponding to this letter
    //
    set_outs_cc (index_d - i);
      
    // check for word being shorter than half the buffer
    //
    if ((name_length_d < (index_d + 1)) && (i == (name_length_d - 1))) {
      break;
    }
  }
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
