// file: ib_load_1.cc
//
// method to shift a name in the buffer
//

// isip include files
//
#include "input_buffer.h"

//-----------------------------------------------------------------------------
// method: shift_cc
//
// arguments: none
//
// return: a logical_1 value indicating success
//
// this method shifts the buffer contents to the right by one place
// and reads a new character in the now vacated first position
//
//-----------------------------------------------------------------------------

logical_1 Input_buffer :: shift_cc () {

  // dummy index variables
  //
  static int_4 out_l = (in_size_d - 1) * num_input_bits_d * sizeof (float_4);
  static int_4 in_l = (in_size_d - 1) * sizeof (char_1);

  // dummy buffers
  //
  char_1 dum_in_l[in_l];
  float_4 dum_out_l[out_l];
  
  // shift the inputs to the right
  //
  memcpy (dum_in_l, input_d, in_l);
  memcpy (input_d + 1, dum_in_l, in_l);

  // shift the corresponding outputs
  //
  memcpy (dum_out_l, output_d, out_l);
  memcpy (output_d + num_input_bits_d, dum_out_l, out_l);

  // increment the index
  //
  index_d ++;
  
  // read a new input letter and set the corresponding outputs
  //
  if (index_d < name_length_d) {
    input_d[0] = name_d[index_d];
  }
  else {
    input_d[0] = ' ';
  }
  set_outs_cc (0);

  // exit gracefully
  //
  return (ISIP_TRUE);
}
