// file: op_add_0.cc
//
// method to add a new pronunciation to the list
//

// isip include files
//
#include "output_pron.h"

//-----------------------------------------------------------------------------
// method: add_pron_cc
//
// arguments:
//    char_1* pron_a: (input) the pronunciation string to be added
//    float_4 score_a: (input) the score associated with this pronunciation
//
// return: a logical_1 to indicate success status
//
// this method adds a new pronunciation to the list
// if the pronunciation is already included it only updates the 
// corresponding score
//
//-----------------------------------------------------------------------------

logical_1 Output_pron :: add_pron_cc (char_1* pron_a, float_4 score_a) {

  // dummy index variables
  //
  int_4 j = 0;
  int_4 tot_flag_l = 0;
  
  // check if this is a unique pronunciation
  //
  for (j = 0; j < num_uniq_prons_d; j++) {
    
    // if the pronunciation exists then update the score and quit
    //
    if (strcmp ((char*)name_prons_d[j], (char*)pron_a) == 0) {
      if (pron_score_d[j] < score_a) {
	pron_score_d[j] = score_a;
      }
      break;
    }
    
    // otherwise continue with a count of non-matching strings
    //
    else {
      tot_flag_l ++;
    }
  }
  
  // otherwise add this new pronunciation to list
  //
  if (tot_flag_l == num_uniq_prons_d) {
    strcpy ((char*)name_prons_d[num_uniq_prons_d], (char*)pron_a);
    pron_score_d[num_uniq_prons_d] =  score_a; // scale_log_d - score_a;
    num_uniq_prons_d ++;
  }
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
