// file: op_cstr_1.cc
//
// constructor
//

// isip include files
//
#include "output_pron.h"

//-----------------------------------------------------------------------------
// method: constructor
//
// arguments:
//    char_1* name_a: (input) the spelling of the name under consideration
//    int_4 num_prons_a: (input) number of pronunciations for this name
//
// return: none
//
// this is the default constructor for the output pronunciations class of 
// a boltzman machine
//-----------------------------------------------------------------------------

Output_pron :: Output_pron (char_1* name_a, int_4 num_prons_a) {

  // dummy variable
  //
  int_4 i = 0;
  
  // initialize parameters
  //
  num_prons_d = num_prons_a;
  num_uniq_prons_d = 0;

  // initialize the name spelling
  //
  name_length_d = strlen ((char*)name_a);
  name_spell_d = new char_1[name_length_d + 1];
  strcpy ((char*)name_spell_d, (char*)name_a);

  // allot space for pronunciations and scores
  //
  pron_score_d = new float_4[num_prons_d];
  name_prons_d = new char_1*[num_prons_d];
  for (i = 0; i < num_prons_d; i++) {
    name_prons_d[i] = new char_1[name_length_d * (MAX_PHONE_SIZE + 1)];
  }
  
  // the standard averaging factor for log-likelihood
  // this is the number of total attempts made to compute
  // the pronunciations
  //
  scale_log_d = log (num_prons_d * DEFAULT_NUM_ATTEMPTS);
  
  // exit gracefully
  //
}
