// file: op_print_0.cc
//
// method to print the list of unique pronunciations to file
//

// isip include files
//
#include "output_pron.h"

//-----------------------------------------------------------------------------
// method: print_prons_cc
//
// arguments:
//    FILE* outfile_a: (input) the file to write
//
// return: a logical_1 to indicate success status
//
// this method writes the sorted list of unique pronunciations along with
// the scores to the output file
//
//-----------------------------------------------------------------------------

logical_1 Output_pron :: print_prons_cc (FILE* outfile_a) {

  // dummy index variable
  //
  int_4 i = 0;
  
  // sort the pronunciations in order of scaled scores
  // the most likely and most frequent pronunciations show up on top
  //
  sort_prons_cc ();
  
  // write the spelling to the output file
  //
  fprintf (outfile_a, "* %s\n", name_spell_d);
  
  // write pronunciation strings to output file
  //
  for (i = 0; i < num_uniq_prons_d; i++) {
    fprintf (outfile_a, "%s", name_prons_d[i]);
    fprintf (outfile_a, "\t Score: %f\n", pron_score_d[i]);
  }
  fprintf (outfile_a, "\n");

  // exit gracefully
  //
  return (ISIP_TRUE);
}
