// file: op_sort_0.cc
//
// method to sort the unique pronunciations
//

// isip include files
//
#include "output_pron.h"

// declaration for static function for comparing scores, to be used in qsort
//
//-----------------------------------------------------------------------------
// method: compare_cc
//
// arguments:
//     char_1* addr1_a: (input) pointer to first element to be compared
//     char_1* addr2_a: (input) pointer to second element to be compared
//
// return: an int_2 value indicating comparison status
//
// this is a non-method static local function used for comparing the scores
// in qsort used in sort_prons_cc () method
//
//-----------------------------------------------------------------------------

// sorting function for scores, to be used in qsort
//
static int compare_cc (char_1* addr1_a, char_1* addr2_a) {

  // get the score values
  //
  float_4 score1_l = 0;
  float_4 score2_l = 0;

  memcpy (&score1_l, addr1_a, sizeof (float_4));
  memcpy (&score2_l, addr2_a, sizeof (float_4));

  // compare scores
  //
  int_2 value_l = 0;
  
  // compare scores and set return value
  //
  if (score1_l > score2_l)
    value_l = -1;
  else if (score1_l < score2_l)
    value_l = 1;

  // exit gracefully
  //
  return ((int) value_l);
}
  
//-----------------------------------------------------------------------------
// method: sort_prons_cc
//
// arguments: none
//
// return: a logical_1 value indicating success
//
// this method sorts the unique pronunciations stored in the list i
// descending order of likelihood scores
//
//-----------------------------------------------------------------------------

logical_1 Output_pron :: sort_prons_cc () {

  // temporary variables
  //
  int_4 i = 0;
  int_4 size_score_l = (int_4) sizeof (float_4);
  int_4 size_pron_l = (int_4) (name_length_d * (MAX_PHONE_SIZE + 1));
  int_4 total_size_l = size_score_l + size_pron_l;
  char_1 temp_addr_l[num_uniq_prons_d][total_size_l];
  
  // copy the address of the float_4 score and the pronunciation string
  //
  for (i = 0; i < num_uniq_prons_d; i++) {
    memcpy (temp_addr_l[i], &pron_score_d[i], size_score_l);
    memcpy (temp_addr_l[i] + size_score_l, name_prons_d[i], size_pron_l);
  }

  // now sort these concatenated strings containing the scores and
  // corresponding pronunciations
  //
  qsort (temp_addr_l, num_uniq_prons_d, total_size_l, compare_cc);

  // copy the scores and strings back in new order
  //
  for (i = 0; i < num_uniq_prons_d; i++) {
    memcpy (&pron_score_d[i], temp_addr_l[i], size_score_l);
    memcpy (name_prons_d[i], temp_addr_l[i] + size_score_l, size_pron_l);
  }
  
  // exit gracefully
  //
  return (ISIP_TRUE);
}
