// file: tree_cstr_0.cc
//

// isip include files
//
#include "tree.h"

#include <integral_constants.h>
#include "tree_constants.h"

// method: destructor
//
// arguments: none
//
// return: none
//
// this is the default destructor for the Tree class
//
//
Tree::~Tree() {

  // exit gracefully
  //
  if (left_child_d != (Tree*)NULL) {
    delete left_child_d;
  }
  
  if (right_child_d != (Tree*)NULL) {
    delete right_child_d;
  }

  if (class_d != (char_1**)NULL) {
    for (int_4 i=0; i<TREE_MAX_NUM_CLASSES; i++) {
      if (class_d[i] != (char_1*)NULL) {
	delete [] class_d[i];
      }
    }
    delete [] class_d;
  }
  
  if (class_count_d != (int_4*)NULL) {
    delete [] class_count_d;
  }
  
  // for debug
  //
  if (debug_level_d > ISIP_DEBUG_DETAILED) {
    fprintf(stdout,"deleting another node %ld\n", counter);
  }
  
  counter--;
  
}




