// file: boltz_random.h
//
// declaration of the globals used for random number generation 
// in the boltzmann machine
//

// make sure definitions are only made once
//
#ifndef __ISIP_BOLTZ_RANDOM
#define __ISIP_BOLTZ_RANDOM

// isip include files
//
#ifndef __ISIP_BOLTZ_CONSTANTS
#include <boltz_constants.h>
#endif

//-----------------------------------------------------------------------------
//
// general constants
//
//-----------------------------------------------------------------------------

// define some constants used in random number generation
//
#define BOLTZ_RAND_INIT              ISIP_RANDSEED
#define BOLTZ_RAND_BIG               1000000000
#define BOLTZ_RAND_SEED              161803398
#define BOLTZ_RAND_ARRAY             56
#define BOLTZ_RAND_CONST             31
#define BOLTZ_RAND_SCALE             (1.0 / BOLTZ_RAND_BIG)

//-----------------------------------------------------------------------------
//
// global functions
//
//-----------------------------------------------------------------------------

// functions defined in boltz_random.cc
//
extern float_4 boltz_random_cc (float_4 low_a, float_4 high_a);

// end of file
//
#endif
