// file: array.cc
//
// definitions of the array class that holds the sorted outputs
//

// isip include files
//
#include "array.h"

//-----------------------------------------------------------------------------
// method: destructor
//
// arguments: none
//
// return: none
//
// this is the destructor for the pronunciations array class
//-----------------------------------------------------------------------------

Array :: ~Array () {
  
  // free memory
  //
  delete [] phones_d;

  //
  // exit gracefully
}

//-----------------------------------------------------------------------------
// method: constructor
//
// arguments: 
//     int_4 row_a (input) : the number of rows
//     int_4 ph_a (input): the number of phones
//
// return: none
//
// this is the constructor for the pronunciations array class
//-----------------------------------------------------------------------------

Array :: Array (int_4 row_a, int_4 ph_a) {

  // assign values
  //
  row_num_d = row_a;
  phone_num_d = ph_a;
  
  // allocate memory for phones
  //
  phones_d = new char_1*[phone_num_d];
  for (int_4 i = 0; i < phone_num_d; i++) {
    phones_d[i] = new char_1[MAX_PHONE_SIZE];
    strcpy ((char*)phones_d[i], "#");
  }
  
  //
  // exit gracefully
}

//-----------------------------------------------------------------------------
// method: get_row_num_cc
//
// arguments: 
//     int_4 row_a (output): the row index
//
// return: a logical_1 to indicate success
//
// this method returns the number of rows
//-----------------------------------------------------------------------------

logical_1 Array :: get_row_num_cc (int_4 &row_a)
{
  // the row index
  //
  row_a = row_num_d;

  // exit gracefully
  //
  return (ISIP_TRUE);
}

//-----------------------------------------------------------------------------
// method: set_phone_cc
//
// arguments: 
//     int_4 ph_a (input): the phone index
//     char_1* phone_a (input): the phone to be set
//
// return: a logical_1 to indicate success
//
// this method puts a phone in the given place in the array
//-----------------------------------------------------------------------------

logical_1 Array :: set_phone_cc (int_4 ph_a, char_1* phone_a) {
  
  // set the phoneme in the given position
  //
  strcpy ((char*)phones_d[ph_a], (char*)phone_a);

  // exit gracefully
  //
  return (ISIP_TRUE);
}

//-----------------------------------------------------------------------------
// method: get_phone_cc
//
// arguments: 
//     int_4 ph_a (input): the phone index
//     char_1* phone_a (output): the phone to be set
//
// return: a logical_1 to indicate success
//
// this method returns the phone
//-----------------------------------------------------------------------------

logical_1 Array :: get_phone_cc (int_4 ph_a, char_1* phone_a) {

  // return the phone in the given position
  //
  strcpy ((char*)phone_a, (char*)phones_d[ph_a]);

   // exit gracefully
  //
  return (ISIP_TRUE); 
}

//-----------------------------------------------------------------------------
// method: check_phone_cc
//
// arguments: 
//     int_4 ph_a (input): the phone index
//     char_1* phone_a (output): the phone to be checked
//
// return: a logical_1 to indicate success
//
// this method checks for a given phone
//-----------------------------------------------------------------------------

logical_1 Array :: check_phone_cc (int_4 ph_a, char_1* phone_a) {
  
  // check the phoneme in the given position
  //
  if (strcmp ((char*)phones_d[ph_a], (char*)phone_a) != 0) {
    return (ISIP_FALSE);
  }

  // exit gracefully
  //
  return (ISIP_TRUE);
}

//-----------------------------------------------------------------------------
// method: print_phone_cc
//
// arguments: 
//     FILE* outfile_a (input): the output file pointer
//
// return: a logical_1 to indicate success
//
// this method prints the phone array to file
//-----------------------------------------------------------------------------

logical_1 Array :: print_array_cc (FILE* outfile_a) {
  
  // print the array to the output file
  //
  for (int_4 i = 0; i < phone_num_d; i++) {
    fprintf (outfile_a, "%s ", phones_d[i]);
  }
  fprintf (outfile_a, "\n");

  // exit gracefully
  //
  return (ISIP_TRUE);
}

//
// end of file
