// file: $ISIP_PRON/src/decision_tree/v1.0/util/generate_tree/gtree_ga_0.cc
//

// isip include files
//
#include "generate_tree.h"

#include <integral_constants.h>
#include "generate_tree_constants.h"

// function: grow_string_arrays_cc
//
// arguments:
//  char_1** &ptr_strings_p: (input/output) arrays to be resized
//  int_4& cur_size_p: (input/output) number of arrays
//  int_4 grow_size_p: (input) amount to increment the array
//
// return:
//  a logical_1 value indicating the status
//
// this method grows arrays by creating a new copy.
//
logical_1 grow_string_arrays_cc(char_1**& ptr_strings_p, int_4& cur_size_p,
			 int_4 grow_size_p) {

  // allocate new, larger, buffers
  //
  char_1** new_array = new char_1*[cur_size_p + grow_size_p];

  // copy pointers
  //
  for (int_4 counter=0; counter<cur_size_p; counter++) {
    new_array[counter] = ptr_strings_p[counter];
  }

  // delete the old space
  //
  delete [] ptr_strings_p;

  // increment the size
  //
  cur_size_p += grow_size_p;

  // swap pointers
  //
  ptr_strings_p = new_array;

  // exit gracefully
  //
  return ISIP_TRUE;
}


