// file: $ISIP_PRON/src/decision_tree/v1.0/util/generate_tree/gtree_search_0.cc
//

// system include files
//
#include <stdio.h>
#include <string.h>

// isip include files
//
#include "generate_tree.h"

#include <integral_constants.h>
#include "generate_tree_constants.h"

// function: lsearch_cc
//
// arguments:
//  char_1* item_a: (input) item searching for
//  char_1** buf_a: (input) buffer to search from
//  int_4 num_items_a: (input) number of items in buffer
//  int_4 debug_level_a: (input) debug level
//
// return:
//  int_4 to indicate location of item if found and -1 if not found
//
// This function does a linear search of the buffer for item.  If found,
// it returns location of item in buffer.  If not found, it returns -1.
// Should do bsearch here but don't have time.  Will go back and modify
// to bsearch for efficiency.
//
//

int_4 lsearch_cc(char_1* item_a, char_1** buf_a, int_4 num_items_a,
		 int_4 debug_level_a) {

  if (debug_level_a > ISIP_DEBUG_BRIEF) {
    fprintf(stdout,"entering search routine\n");
  }
  // location of item
  //
  int_4 loc = 0;
  logical_1 found = ISIP_FALSE;

  while ((found == ISIP_FALSE) && (loc < num_items_a)) {
    if (strcmp((char*)item_a, (char*)buf_a[loc]) == (int_4)0) {
      found = ISIP_TRUE;
    }
    else {
      loc++;
    }
  }
  if (found == ISIP_TRUE) {
    return (loc);
  }
  else {
    return -1;
  }
}

