// file: $ISIP_PRON/src/decision_tree/v1.0/util/rebuild/r_gp_0.cc
//

// a simple command line parser
//

// system include files
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
// isip include files
//
#include <integral_constants.h>
#include "rebuild_constants.h"

#include "rebuild.h"

logical_1 get_parameters_cc(int_4& nbest_a, int_4& max_a, int_4& context_a,
			    char_1* fname_in_a, char_1* fname_out_a,
			    int_4 argc, char_1** argv) {
  
  // main decoding loop
  //
  int_4 last_index = argc;

  // if no arguments are given then print out a help message
  //
  if (last_index == (int)1) {
    char_1 tmp_string[ISIP_MAX_STRING_LENGTH];
    sprintf((char*)tmp_string,
            (char*)ISIP_HELP_FORMAT, (char*)R_HELP_FILE);
    system((char*)tmp_string);
    
    // exit gracefully
    //
    exit (ISIP_NO_ERROR);
  }
  
  for (int_4 index=1; index<last_index; index++) {
 
    // check for help
    //
    if (strcmp((char*)ISIP_HELP_OPTION, (char*)argv[index]) == (int)0) {
      char_1 tmp_string[ISIP_MAX_STRING_LENGTH];
      sprintf((char*)tmp_string,
              (char*)ISIP_HELP_FORMAT, (char*)R_HELP_FILE);
      system((char*)tmp_string);
    }

    // pick off context
    //
    if (strcmp((char*)R_CONTEXT_OPT, (char*)argv[index]) == 0) {
      context_a=atoi((char*)argv[++index]);
    }
    
    // pick off nbest
    //
    else if (strcmp((char*)R_NBEST_OPT, (char*)argv[index]) == 0) {
      nbest_a=atoi((char*)argv[++index]);
    }
    
    // pick off max
    //
    else if (strcmp((char*)R_MAX_OPT, (char*)argv[index]) == 0) {
      max_a=atoi((char*)argv[++index]);
    }
    
    // pick off the filename
    //
    else if (strcmp((char*)R_INPUT_OPT, (char*)argv[index]) == 0) {
      strcpy((char*)fname_in_a, (char*)argv[++index]);
    }
    
    else if (strcmp((char*)R_OUTPUT_OPT, (char*)argv[index]) == 0) {
      strcpy((char*)fname_out_a, (char*)argv[++index]);
    }
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
