// file: text_to_speech_constants.h
//
// constants file for text to speech generation using rsynth
//

#ifndef __ISIP_TTS_CONSTANTS
#define __ISIP_TTS_CONSTANTS

// define some constants related to help generation
//
#define MAX_STRING_LENGTH 1024
#define MAX_FNAME_LENGTH 512

// define standard return values for programs and methods
//
#define NO_ERROR 0
#define ERROR 1

// define logical true and false
//
#define FALSE 0
#define TRUE 1

// define NULL character
//
#define NULL_CHAR '\0'

// define command line options
//
#define TTS_MAP_OPT "-map"
#define TTS_WORD_OPT "-word"
#define TTS_PHONE_OPT "-phone"
#define TTS_OUTPUT_OPT "-output"
#define TTS_PIPE_OPT "-pipe"
#define TTS_AUDIO_OPT "-audio"
#define TTS_SF_OPT "-sf"
#define TTS_SPEED_OPT "-speed"
#define TTS_HELP_OPT "-help"
#define TTS_HELP_FORMAT "more %s"
#define TTS_HELP_FILE "$ISIP_PRON_DEMO/src/util/text_to_speech/text_to_speech.help"

// define options that rsynth uses
//
#define TTS_RSYNTH_OPTS 7
#define TTS_RSYNTH_AUDIO "-a"
#define TTS_RSYNTH_OUTPUT "-o"
#define TTS_RSYNTH_SF "-r"
#define TTS_RSYNTH_SPEED "-S"

// define default options
//
#define TTS_DEFAULT_SF 8000.0
#define TTS_DEFAULT_SPEED 1.0
#define TTS_DEFAULT_MAP "$ISIP_PRON_DEMO/src/include/arpabet_to_worldbet.map"

// define translation flags
//
#define TTS_ARPABET 0
#define TTS_WORLDBET 1

// define tmp file and its extensions
//
#define TTS_TEMPLATE "/tmp/tmp_file_XXXXXX"
#define TTS_FILE_EXT ".au"

// define array size
//
#define TTS_ARRAY_SIZE 10
#define TTS_MAX_PHONE_LENGTH 10

// define phone delimiter
//
#define TTS_DELIMITER " "

// define COMMENT and blank character
//
#define TTS_COMMENT_CHAR '#'
#define TTS_BLANK_CHAR ' '

// define file read and write modes
//
#define TTS_READ "r"
#define TTS_WRITE "w"

// define input and output formats
//
#define TTS_READ_FORMAT_A "%s[^\t\n]"
#define TTS_READ_FORMAT_B "%[\t]"
#define TTS_READ_FORMAT_C "%[^\n]"
#define TTS_READ_FORMAT_D "%[\n]"
#define TTS_PRINT_FORMAT_A "* %s\n%s\n\n"

// define enviroment delimiter
//
#define TTS_ENV_DELIMITERS "$~(){}[]?"

// end of file
//
#endif
