// file: $DT/util/analyze_dtree/v1.0/ad_gp_0.cc
//
// a simple command line parser
//
 
// isip include files
//
#include "analyze_dtree.h"

#include "analyze_dtree_constants.h"
#include <integral_constants.h>

// function: get_parameters_cc
//
// arguments:
//
// return value: a logical_1 indicating status
//
// This function parses command line arguments.
//
//
logical_1 get_parameters_cc(char_1*& param_fname_a, char_1*& attr_fname_a,
			    char_1*& input_fname_a, char_1*& output_fname_a,
			    int_4& debug_level_a, int_4 argc_a,
			    char_1** argv_a) {

  // main decoding loop
  //
  int_4 last_index = argc_a;
  
  char_1 tmp_string[ISIP_MAX_STRING_LENGTH];
  
  // if no arguments are given then print out a help message
  //
  if (last_index == (int)1) {
    sprintf((char*)tmp_string,
            (char*)ISIP_HELP_FORMAT, (char*)AD_HELP_FILE);
    system((char*)tmp_string);
    
    // exit gracefully
    //
    exit (ISIP_NO_ERROR);
  }
  int_4 input_flag = ISIP_TRUE;

  for (int_4 index=1; index<last_index; index++) {
 
    // check for help
    //
    if (strcmp((char*)ISIP_HELP_OPTION, (char*)argv_a[index]) == (int)0) {
      sprintf((char*)tmp_string,
              (char*)ISIP_HELP_FORMAT, (char*)AD_HELP_FILE);
      system((char*)tmp_string);
      
      // exit gracefully
      //
      exit(ISIP_NO_ERROR);
    }
    
    // pick off param option
    //
    else if (strcmp((char*)AD_PARAM_OPT, (char*)argv_a[index]) == (int)0) {
      strcpy ((char*)tmp_string, (char*)argv_a[++index]);
      param_fname_a = new char_1[strlen((char*)tmp_string)+1];
      strcpy ((char*)param_fname_a, (char*)tmp_string);
    }

    // pick off attribute option
    //
    else if (strcmp((char*)AD_ATTR_OPT, (char*)argv_a[index]) == (int)0) {
      strcpy ((char*)tmp_string, (char*)argv_a[++index]);
      attr_fname_a = new char_1[strlen((char*)tmp_string)+1];
      strcpy ((char*)attr_fname_a, (char*)tmp_string);
    }
    
    // pick off debug option
    //
    else if (strcmp((char*)AD_DEBUG_OPT, (char*)argv_a[index]) == (int)0) {
      
      // save the debug level
      //
      debug_level_a = (int_4)atoi((char*)argv_a[++index]);
    }

    // pick off input option
    //
    else if (input_flag) {
      strcpy ((char*)tmp_string, (char*)argv_a[index]);
      input_fname_a = new char_1[strlen((char*)tmp_string)+1];
      strcpy ((char*)input_fname_a, (char*)tmp_string);
      input_flag = ISIP_FALSE;
    }
    
    // pick off output option
    //
    else if (!input_flag) {
      strcpy ((char*)tmp_string, (char*)argv_a[index]);
      output_fname_a = new char_1[strlen((char*)tmp_string)+1];
      strcpy ((char*)output_fname_a, (char*)tmp_string);
    }
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}

